<?php

class User
{
	private $get;
	private $post;
	private $smarty;
	private $db;
	private $auth_module;
	private $admin; //refference to admin interface


	/**
	 * Constructor
	 *
	 * @param array $post sanitized POST request
	 * @param array $get sanitized GET
	 */
	public function __construct($post, $get)
	{
		$this->auth_user = $login;
		$this->get = $this->clean($get);
		$this->post = $post;
		$this->smarty = new Smarty;
		//$this->smarty->compile_check = true;
		//$this->smarty->debugging = true;
		$this->db = db_connect();
		$this->auth_module = new AuthModule($this->db);
		$this->smarty->assign('level', $this->auth_module->get_level());
		global $account_url;
		$this->smarty->assign('account_url', $account_url);
		global $app_path;
		$this->smarty->assign('app_path', $app_path);
	}

	/**
	 * Execute page
	 *
	 */
	public function execute()
	{
		include 'help/Help.php';
			

		if (!is_numeric($this->auth_module->get_id()))
		{
			global $account_url;
   			header('Location: '.$account_url.'index.php?ref=/');
			die();
		}

		//$admin = new Contents_waiting_checked($this->post, $this->get, 0, false);
		$admin = new Contents_publications($this->post, $this->get, 0, false);
		$admin->smarty = $this->smarty;
		$this->admin = $admin;

		if ($this->post['delete_author']) {
			try {
				if ($this->auth_module->get_level() > 1)
					throw new SAException("You don't have sufficient rights.");
			 	$a = $this->post['authors'];
				if (sizeof($a) != 0)
				{
					$affected = 0;
					foreach ($a as $i => $value)
						if (!$affected) $affected = delete_author($this->db, $value);
						else delete_author($this->db, $value);
				}

				if ($affected)
					$this->smarty->assign("operation_success", "Authors has been deleted.");
				else if (sizeof($a) == 0)
					$this->smarty->assign("operation_error", "No author has been chosen.");
				else
					$this->smarty->assign("operation_error", "This record can't be deleted because is used with some publications.");
				$this->display_modify_publication($this->get['pid']);
			} catch (Exception $e) {
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_modify_publication($this->get['pid']);
			}


		} else if ($this->post['add_author']) {
			try {
				if ($this->auth_module->get_level() > 1)
					throw new SAException("You don't have sufficient rights.");
				add_author($this->db, $this->post['author_surname'], $this->post['author_middle_name'], $this->post['author_name'], $this->auth_module->get_id());
				$this->smarty->assign("operation_success", "Author has been added.");
				$this->display_modify_publication($this->get['pid']);
			} catch (SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_modify_publication($this->get['pid']);
			}
		} elseif ($this->post['add_publisher']) {
			try {
				if ($this->auth_module->get_level() > 1)
					throw new SAException("Tou don't have sufficient rights.");
				add_publisher($this->db, $this->post['publisher_name'], $this->post['publisher_address'], $this->auth_module->get_id());
				$this->smarty->assign('operation_success', 'Publisher has been added.');
				$this->display_modify_publication($this->get['pid']);
			} catch (SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_modify_publication($this->get['pid']);
			}
		} elseif ($this->post['add_journal']) {
			try {
				if ($this->auth_module->get_level() > 1)
					throw new SAException("Tou don't have sufficient rights.");
				add_journal($this->db, $this->post['journal_name'], $this->post['journal_issn'], $this->auth_module->get_id());
				$this->smarty->assign('operation_success', 'Journal has been added.');
				$this->display_modify_publication($this->get['pid']);
			} catch (SLException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_modify_publication($this->get['pid']);
			}
		} elseif ($this->post['add_conference']) {
			try {
				if ($this->auth_module->get_level() > 1)
					throw new SAException("You don't have sufficient rights.");
				extract($this->post);
				add_conference($this->db, $conference_name, $conference_abbreviation, $w_year, $w_from, $w_to, $location, $isbn, $this->auth_module->get_id());
				$this->smarty->assign('operation_success', 'Conference has been added.');
				unset ($_SESSION['feedback_modify']['conference_name']);
				unset ($_SESSION['feedback_modify']['conference_abbreviation']);
				unset ($_SESSION['feedback_modify']['w_year']);
				unset ($_SESSION['feedback_modify']['w_from']);
				unset ($_SESSION['feedback_modify']['w_to']);
				unset ($_SESSION['feedback_modify']['isbn']);
				$this->display_modify_publication($this->get['pid']);
			} catch (SLException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_modify_publication($this->get['pid']);
			}
		} elseif ($this->post['add_conference2']) {
			try {
				if ($this->auth_module->get_level() > 1)
					throw new SAException("You don't have sufficient rights.");
				extract($this->post);
				add_conference2($this->db, $conference_name2, $conference_abbreviation2, $this->auth_module->get_id(), $conference_description2, $conference_first_year2);
				$this->smarty->assign('operation_success', 'Conference2 has been added.');
				unset ($_SESSION['feedback_modify']['conference_name2']);
				unset ($_SESSION['feedback_modify']['conference_abbreviation2']);
				unset ($_SESSION['feedback_modify']['conference_description2']);
				unset ($_SESSION['feedback_modify']['conference_first_year2']);
				unset ($_SESSION['new_conference2']);
				$_SESSION['new_conference2'] = $conference2_id;
			
				$this->display_modify_publication($this->get['pid']);
			} catch (SLException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_modify_publication($this->get['pid']);
			}

		}
		//add conference_year with publisher
		elseif ($this->post['add_conference_year_c']) {
			try {
				extract($this->post);
					if(!$publisher_c){
						$publisher_c=0;
					}
				add_conference_year_c($this->db, $conference_year_name, $conference2, $conference_year_year, $conference_year_from, $conference_year_to, $conference_year_location, $conference_year_isbn, $conference_year_description, $publisher_c, $this->auth_module->get_id());
				$this->smarty->assign('operation_success', 'Conference year has been added.');
				unset ($_SESSION['feedback_modify']['conference_year_name']);
				unset ($_SESSION['feedback_modify']['conference_year_year']);
				unset ($_SESSION['feedback_modify']['conference_year_from']);
				unset ($_SESSION['feedback_modify']['conference_year_to']);
				unset ($_SESSION['feedback_modify']['conference_year_location']);
				unset ($_SESSION['feedback_modify']['conference_year_isbn']);
				unset ($_SESSION['feedback_modify']['conference_year_description']);
				unset ($_SESSION['feedback_modify']['publisher_c']);
				$this->display_modify_publication($this->get['pid']);
			} catch (SLException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
				$this->display_modify_publication($this->get['pid']);
			}
		}
 
		elseif ($this->post['add_annotation']) {
			try {
				add_annotation($this->db, $this->get['pid'], $this->post['annotation'], $this->post['scope'], $this->auth_module->get_id());
				$this->smarty->assign('operation_success', 'Annotation has been added.');
				$this->display_annotations($this->get['pid']);
			} catch (SLException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_annotations($this->get['pid']);
			}
		} elseif ($this->post['update_annotation']) {
			try {
				if (annotation_is_owned($this->db, $this->post['id'], $this->auth_module->get_id())
				|| $this->auth_module->is_admin())
					update_annotation($this->db, $this->post['id'], $this->post['annotation'], $this->auth_module->get_id());
				else
					throw new Exception("You don't have rights to manipulate with this annotation.");
				$this->smarty->assign('operation_success', 'Annotation has been updated.');
				$this->display_annotations($this->get['pid']);
			} catch (SLException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_annotations($this->get['pid']);
			}
		} elseif ($this->post['update_publisher']) {
			try {
				if ($this->auth_module->get_level() > 1)
					throw new SAException("Tou don't have sufficient rights.");
				update_publisher($this->db, $this->post['publisher'], $this->post['publisher_name'], $this->post['publisher_address'], $this->auth_module->get_id(), false, $this->get['pid']);
				$this->smarty->assign('operation_success', 'Publisher has been updated');
				$this->display_modify_publication($this->get['pid']);
			} catch (SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_modify_publication($this->get['pid']);
			}
		} elseif ($this->post['update_journal']) {
			try {
				if ($this->auth_module->get_level() > 1)
					throw new SAException("Tou don't have sufficient rights.");
				update_journal($this->db, $this->post['journal'], $this->post['journal_name'], $this->post['journal_issn'], $this->auth_module->get_id(), false, $this->get['pid']);
				$this->smarty->assign('operation_success', 'Journal has been updated');
				$this->display_modify_publication($this->get['pid']);
			} catch (SLException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_modify_publication($this->get['pid']);
			}
		} elseif ($this->post['update_conference']) {
			try {
				if ($this->auth_module->get_level() > 1)
					throw new SAException("Tou don't have sufficient rights.");
				extract($this->post);
				update_conference($this->db, $conference, $conference_name, $conference_abbreviation, $w_year, $w_from, $w_to, $location, $isbn, $this->auth_module->get_id(), false, $this->get['pid']);
				$this->smarty->assign('operation_success', 'Conference has been updated');
				$this->display_modify_publication($this->get['pid']);
			} catch (SLException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_modify_publication($this->get['pid']);
			}
		}
		elseif ($this->post['update_conference2']) {
			try {
				extract($this->post);
				update_conference2($this->db, $conference2, $conference_name2, $conference_abbreviation2, $conference_first_year2, $conference_description2, $this->auth_module->get_id());
				$this->smarty->assign('operation_success', 'Conference2 has been updated');
				$this->display_modify_publication($this->get['pid']);
			} catch (SLException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_modify_publication($this->get['pid']);
			}
		}
		elseif ($this->post['update_conference_year_c'])
		{
			try {
				extract($this->post);
				if($publisher_sel_c){
					$publisher_c=$publisher_sel_c;
				}
				update_conference_year_p($this->db, $conference_year, $conference_year_name, $conference_year_year, $conference_year_from, $conference_year_to, $conference_year_location, $conference_year_isbn,$conference_year_description, $publisher_c, $this->auth_module->get_id());
				$this->smarty->assign('operation_success', 'Conference year has been updated');
				$this->display_modify_publication($this->get['pid']);
			} catch (Exception $e) {
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_modify_publication($this->get['pid']);
			}
		}
		elseif ($this->post['delete_publisher']) {
			try {
				if ($this->auth_module->get_level() > 1)
					throw new SAException("Tou don't have sufficient rights.");
				$affected = delete_publisher($this->db, $this->post['publisher']);
				if ($affected)
					$this->smarty->assign("operation_success", "Publisher has been deleted.");
				else {
					$this->smarty->assign("operation_error", "This record can't be deleted because is used with some publications.");
				}
				$this->display_modify_publication($this->get['pid']);
			} catch (Exception $e) {
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_modify_publication($this->get['pid']);
			}
		} elseif ($this->post['delete_journal']) {
			try {
				if ($this->auth_module->get_level() > 1)
					throw new SAException("Tou don't have sufficient rights.");
				$affected = delete_journal($this->db, $this->post['journal']);
				if ($affected)
					$this->smarty->assign("operation_success", "Journal has been deleted.");
				else {
					$this->smarty->assign("operation_error", "This record can't be deleted because is used with some publications.");
				}
				$this->display_modify_publication($this->get['pid']);
			} catch (Exception $e) {
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_modify_publication($this->get['pid']);
			}
		} elseif ($this->post['delete_conference']) {
			try {
				if ($this->auth_module->get_level() > 1)
					throw new SAException("Tou don't have sufficient rights.");
				$affected = delete_conference($this->db, $this->post['conference']);
				if ($affected)
					$this->smarty->assign("operation_success", "Conference has been deleted.");
				else {
					$this->smarty->assign("operation_error", "This record can't be deleted because is used with some publications.");
				}
				$this->display_modify_publication($this->get['pid']);
			}
			catch (Exception $e)
			{
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_modify_publication($this->get['pid']);
			}
		}
		elseif ($this->post['delete_conference2']) {
			try {
				$affected = delete_conference2_check($this->db, $this->post['conference2']);
				if ($affected)
					$this->smarty->assign("operation_success", "Conference2 has been deleted.");
				else {
					$this->smarty->assign("operation_error", "The record can't be deleted because is used by some publications.");
				}
				$this->display_modify_publication($this->get['pid']);
			} catch (Exception $e) {
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_modify_publication($this->get['pid']);
			}
		} elseif ($this->post['delete_conference_year']) {
			try {
				$affected = delete_conference_year_check($this->db, $this->post['conference_year']);
				if ($affected)
					$this->smarty->assign("operation_success", "Conference year has been deleted.");
				else {
					$this->smarty->assign("operation_error", "The record can't be deleted because is used by some publications.");
				}
				$this->display_modify_publication($this->get['pid']);
			} catch (Exception $e) {
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_modify_publication($this->get['pid']);			}

		}
		 elseif ($this->post['delete_annotation']) {
			try {
				$affected = delete_annotation($this->db, $this->post['id'], $this->auth_module->get_id());
				if ($affected)
					$this->smarty->assign("operation_success", "Annotation has been deleted.");
				else {
					$this->smarty->assign("operation_error", "You can't delete the annotation, it doesn't belong to you.");
				}
				$this->display_annotations($this->get['pid']);
			}
			catch (Exception $e)
			{
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_annotations($this->get['pid']);
			}

		}elseif ($this->post['set_my_publication'] && $this->get['pid']){
			try {
				$this->set_my_publication($this->get['pid'], $this->auth_module->get_id());
				$this->smarty->assign('operation_success', 'Publication is now in Your Publications.');
				$this->smarty->display('user_publ.tpl');				
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				//die($e->getMessage());
				$this->smarty->assign("operation_error", $e->getMessage());
				$this->display_overview($this->get['pid']);
			}

		} elseif ($this->post['modify_form'] && $this->get['pid']) {
			try {
				if ($this->auth_module->get_level() > 1)
					throw new SAException("Tou don't have sufficient rights.");
				if ($this->post['save'])
				{ //save changes
					$admin->validate_modify_publication();
					$admin->update_publication($this->get['pid']);
					$admin->clear_temporaries();
					$this->smarty->assign('operation_success', 'Publication has been updated.');
					//$this->smarty->assign('refresh', "1 ; URL=index.php?tab=3&amp;pid=".$this->get['pid']);
					$this->display_modify_publication($this->get['pid']);
				}
				elseif ($this->post['change_pub_type']) { //change pub_type
					$_SESSION['feedback_modify'] = $this->post;
					$this->display_modify_publication($this->get['pid']);
				}
				elseif ($this->post['add_attribute'])
				{ //add temporary attribute
					$admin->validate_add_att();
					$admin->add_tmp_attribute($this->post['new_attribute_name'], $this->post['new_attribute_description'], $this->post['new_attribute_value']);
					$this->smarty->assign('operation_success', 'Attribute is going to be added after you save the publication.');
					$this->display_modify_publication($this->get['pid']);
				}
				elseif ($this->post['mark_attributes_deleted'])
				{  //unset all temporary attributes, mark real attributes as deleted
					$_SESSION['feedback_modify'] = $this->post;
					$_SESSION['attributes_deleted'] = 1;
					unset($_SESSION['tmp_attr']);
					$this->smarty->assign('operation_success', 'After you update the publication, the private attributes will be deleted;');
					$this->display_modify_publication($this->get['pid']);
				}
				elseif ($this->post['select_author'])
				{ //add author from publication
					$authors = $this->post["authors"];
					if (!is_null($authors))
						$admin->add_authors_to_temp($authors);
					$this->display_modify_publication($this->get['pid']);
				}
				elseif ($this->post['deselect_author'])
				{ //remove author from publication
					$authors = $this->post["selected_authors"];
					if (!is_null($authors))
						$admin->remove_authors_from_temp($authors);
					$this->display_modify_publication($this->get['pid']);
				}
				elseif ($this->post['up']) /* move author up */
				{
				 	$a = $this->post['selected_authors'];
				 	if (is_array($a))
				 	{
						$id = $a[0];
				 		$pos = array_search($id, $_SESSION["selected_authors"]);
				 		if ($pos != 0)
				 		{
				 			$tmp = $_SESSION["selected_authors"][$pos - 1];
				 			$_SESSION["selected_authors"][$pos - 1] = $id;
				 			$_SESSION["selected_authors"][$pos] = $tmp;
				 		}
				 	}
				 	$this->display_modify_publication($this->get['pid']);
				}
				elseif ($this->post['down']) /* move author down */
				{
				 	$a = $this->post['selected_authors'];
				 	if (is_array($a))
				 	{
						$id = $a[0];
				 		$pos = array_search($id, $_SESSION["selected_authors"]);
				 		if ($pos != count($_SESSION["selected_authors"]) - 1)
				 		{
				 			$tmp = $_SESSION["selected_authors"][$pos + 1];
				 			$_SESSION["selected_authors"][$pos + 1] = $id;
				 			$_SESSION["selected_authors"][$pos] = $tmp;
				 		}
				 	}
				 	$this->display_modify_publication($this->get['pid']);
				}
			} catch(SAException $s) {
				die($s->getMessage().'<br/>Line:'.$s->getLine());
			} catch (Exception $e) {
				$admin->feedback_modify();
				$this->smarty->assign('operation_error', $e->getMessage());
				$this->display_modify_publication($this->get['pid']);
			}
		} elseif ($this->get['search_my_publications']) {
			$this->smarty->assign('level', $this->auth_module->get_level());

			$this->init_search_bar();
			$this->smarty->assign('logged_info', $this->auth_module->get_login());
			if (!empty($this->get['keywords']))
			{
				$categories = $this->get['categories'];
				$this->smarty->display('header.tpl');
				$this->smarty->display('header2.tpl');
				$this->display_search_results_document_my_publications(remove_diac($this->get['keywords']), $categories);
			}
			elseif (!empty($this->get['authors']))
			{
				$categories = $this->get['categories'];
				$this->smarty->display('header.tpl');
				$this->smarty->display('header2.tpl');
				$this->display_search_results_author_my_publications($this->get['authors'], $categories);
				$this->display_search_results_document_my_publications($this->get['authors'], $categories);
			}
			elseif (!empty($this->get['categories']) && empty($this->get['authors']) && empty($this->get['keywords']))
			{
				$categories = $this->get['categories'];
				$this->smarty->display('header.tpl');
				$this->smarty->display('header2.tpl');
				$this->display_search_results_categories_my_publications($categories);
			}
			elseif (is_numeric($this->get['pid']) && (empty($this->get['tab']) || $this->get['tab'] == 1))
			{
				$admin->clear_temporaries();
				$this->display_publication($this->get['pid']);
			}
			elseif (is_numeric($this->get['pid']) && $this->get['tab'] == 2)
			{
				if ($this->auth_module->get_level() <= 1) //only role administrator and submitter may modify publication
				{
					$admin->clear_temporaries();
					$this->display_modify_publication($this->get['pid']);
				}
				else
				{
					$this->smarty->assign("operation_error", "You don't have rights to modify publications.");
					$this->display_publication($this->get['pid']);
				}
			}
			elseif (is_numeric($this->get['pid']) && $this->get['tab'] == 3)
			{
				$admin->clear_temporaries();
				$this->display_annotations($this->get['pid']);
			}
			else
				$this->display_front_page();

		} else {
			$this->smarty->assign('level', $this->auth_module->get_level());

			$this->init_search_bar();
			$this->smarty->assign('logged_info', $this->auth_module->get_login());
			if (!empty($this->get['keywords']))
			{
				$categories = $this->get['categories'];
				$this->smarty->display('header.tpl');
				$this->smarty->display('header2.tpl');
				$this->display_search_results_document(remove_diac($this->get['keywords']), $categories);
			}
			elseif (!empty($this->get['authors']))
			{
				$categories = $this->get['categories'];
				$this->smarty->display('header.tpl');
				$this->smarty->display('header2.tpl');
				$this->display_search_results_author($this->get['authors'], $categories);
				$this->display_search_results_document($this->get['authors'], $categories);
			}
			elseif (!empty($this->get['categories']) && empty($this->get['authors']) && empty($this->get['keywords']))
			{
				$categories = $this->get['categories'];
				$this->smarty->display('header.tpl');
				$this->smarty->display('header2.tpl');
				$this->display_search_results_categories($categories);
			}
			elseif (is_numeric($this->get['pid']) && (empty($this->get['tab']) || $this->get['tab'] == 1))
			{
				$admin->clear_temporaries();
				$this->display_publication($this->get['pid']);
			}
			elseif (is_numeric($this->get['pid']) && $this->get['tab'] == 2)
			{
				if ($this->auth_module->get_level() <= 1) //only role administrator and submitter may modify publication
				{
					$admin->clear_temporaries();
					$this->display_modify_publication($this->get['pid']);
				}
				else
				{
					$this->smarty->assign("operation_error", "You don't have rights to modify publications.");
					$this->display_publication($this->get['pid']);
				}
			}
			elseif (is_numeric($this->get['pid']) && $this->get['tab'] == 3)
			{
				$admin->clear_temporaries();
				$this->display_annotations($this->get['pid']);
			}
			else
				$this->display_front_page();
		}
	}

	/**
	 * clean up messy input
	 *
	 * @param array $get  data sent via GET method
	 */
	private function clean($get)
	{
		$get['page'] = (int)$get['page'];
		if (is_array($get['categories'])) foreach ($get['categories'] as $i => $v) {
			$get[$i] = (int)$v;
		}
		return $get;
	}

	/**
	 * Initialize search bar
	 *
	 */
	private function init_search_bar()
	{
		if($this->get['categories'])
			$this->smarty->assign('enable_categories', 1);

		$sql = "SELECT id, name
				FROM `categories`
				ORDER BY name";
		$categories = $this->db->getAssoc($sql);
		$this->smarty->assign('categories', $categories);
		$this->smarty->assign('keywords', stripslashes($this->get['keywords']));
		$this->smarty->assign('authors', stripslashes($this->get['authors']));
		$this->smarty->assign('operator', $this->get['operator']);
		$this->smarty->assign('selected_categories', $this->get['categories']);

	}

	/**
	 * Set as my publication
	 *
	 * @param int $publication_id
	 * @param int $submitter_id
	 */
	public function set_my_publication($publication_id, $submitter_id)
	{
		$this->db->autoCommit(false);
		//insert into `submitter_has_publication`
		$res =& $this->db->query("INSERT IGNORE INTO submitter_has_publication(submitter_id, publication_id) values($submitter_id, $publication_id)");
		if(DB::isError($res)) {
			$this->db->rollback();
			throw new SAException($res->getMessage());
		}
		//$this->db->commit();
	}



	/**
	 * Choose format for displayed citations
	 *
	 */
	private function choose_format()
	{
		if(!$this->post['format'] && !$_SESSION['selected_format'])
		{
			$_SESSION['selected_format'] = 1;
		}
		elseif ($this->post['format'])
		{
			$_SESSION['selected_format'] = intval($this->post['format']);
		}
	}

	/**
	 * Init "previous"/ "next" page navigators and order by links
	 *
	 * @param int $result_size
	 * @param int $bulk wanted result size
	 * @param int $page page number
	 * @param string $order_by
	 */
	private function init_arrows($result_size, $bulk, $page, $order_by)
	{
		//init page navigators
		$query_string = $_SERVER['QUERY_STRING'];
		if (!ereg('page=[0-9]*', $query_string)) {
			$query_string_left = query_string.'&page='.($page-1);
			$query_string_right = $query_string.'&page='.($page+1);
		} else {
			$query_string_left = preg_replace('/page=[0-9]*/', 'page='.($page-1), $query_string);
			$query_string_right = preg_replace('/page=[0-9]*/', 'page='.($page+1), $query_string);
		}
		if (!ereg('order_by=[a-z]*', $query_string_left))
			$query_string_left = $query_string_left."&order_by=$order_by";
		else
			$query_string_left = preg_replace('/order_by=[a-z]*/', "order_by=$order_by", $query_string_left);

		if (!ereg('order_by=[a-z]*', $query_string_right))
			$query_string_right = $query_string_right."&order_by=$order_by";
		else
			$query_string_right = preg_replace('/order_by=[a-z]*/', "order_by=$order_by", $query_string_right);

		if ($result_size == $bulk)
		{
			$this->smarty->assign('rarrow', htmlentities($query_string_right));
		}
		if ($page != 0 && $result_size == 0) //user clicked to the 'next arrow', but there are no results any more
		{
			$pos = strpos($_SERVER['HTTP_REFERER'], '&page=');
			$loc = substr($_SERVER['HTTP_REFERER'], 0, $pos)."&order_by=$order_by".'&page='.($page-1);
			header("Location: $loc");
			die;
		}
		if ($page != 0)
		{
			$this->smarty->assign('larrow', htmlentities($query_string_left));
		}
		//order_by links
		if (!ereg('order_by=[a-z]*', $query_string))
			$query_string = $query_string."&order_by=$order_by";
		else
			$query_string_left = preg_replace('/order_by=[a-z]*/', "order_by=$order_by", $query_string_left);
		$this->smarty->assign('o_title', htmlentities(preg_replace('/order_by=[a-z]*/', "order_by=title", $query_string)));
		$this->smarty->assign('o_relevancy', htmlentities(preg_replace('/order_by=[a-z]*/', "order_by=relevancy", $query_string)));
		$this->smarty->assign('o_date', htmlentities(preg_replace('/order_by=[a-z]*/', "order_by=date", $query_string)));

	}

	/**
	 * Display page containing a list of found publications. To each publication
	 * attach a piece of text where the matching phrase was found.
	 *
	 * @param string $keywords sanitized search keywords
	 * @param array $categories ids of selected categories
	 */
	private function display_search_results_document($keywords, $categories)
	{
		$_SESSION['search_qs'] = htmlentities($_SERVER['QUERY_STRING']); //save query string
		$this->db->setFetchMode(DB_FETCHMODE_ORDERED);

		$order_by = $this->get['order_by'];
		switch ($order_by)
		{
			case 'title':
				$order_clause = "ORDER BY p.title ASC";
				break;
			case 'date':
				$order_clause = "ORDER BY p.issue_date DESC, p.title ASC";
				break;
			default:
				$order_by = 'relevance';
				$order_clause = "ORDER BY 5 * MATCH(d.title) AGAINST ('$keywords') + MATCH(d.content) AGAINST ('$keywords') DESC";
		}

		$bulk = 20;
		$page = is_numeric($this->get['page']) ? $this->get['page'] : 0;
		$offset = $bulk * $page;
		$limit = " LIMIT $offset, $bulk";

		if (is_array($categories))
		{
			if ($this->get['operator'] == 'or')
			{ //operator between categories is 'OR'
				$cat_ids = ids_clause($categories);
				$sql = "SELECT DISTINCT p.id, p.title, d.content, p.pub_type
					FROM `documents` d
						JOIN `publication` p ON p.id = d.publication_id
						JOIN `categories_has_publication` c ON p.id = c.publication_id
					WHERE (MATCH(d.title) AGAINST ('$keywords' IN BOOLEAN MODE) OR MATCH(d.content) AGAINST ('$keywords' IN BOOLEAN MODE))
						AND c.categories_id IN ($cat_ids)
					$order_clause
					$limit";
			}
			else
			{ //operator between categories is 'AND'
				$num_cat = count($categories);
				$where_clause = arr_condition($categories, 'categories_id');
				$sql = "SELECT p.id, p.title, d.content, p.pub_type
					FROM `documents` d
						JOIN `publication` p ON p.id = d.publication_id
					WHERE (MATCH(d.title) AGAINST ('$keywords' IN BOOLEAN MODE) OR MATCH(d.content) AGAINST ('$keywords' IN BOOLEAN MODE))
						AND p.id IN (
							SELECT publication_id
							FROM `categories_has_publication`
							WHERE $where_clause
							GROUP BY (publication_id)
							HAVING COUNT(publication_id) = '$num_cat'
						)
					$order_clause
					$limit";
			}
		} else { //no categories selected
			if ($this->get['advanced'] != 'false') //advanced search is activated
			{
				$sql = "SELECT p.id, p.title, d.content, p.pub_type
					FROM `documents` d JOIN `publication` p ON p.id = d.publication_id
					WHERE (MATCH(d.title) AGAINST ('$keywords' IN BOOLEAN MODE) OR MATCH(d.content) AGAINST ('$keywords' IN BOOLEAN MODE))
						AND p.id NOT IN (
							SELECT publication_id
							FROM `categories_has_publication`
						)
					$order_clause
					$limit";
			}
			else
			{
				$sql = "SELECT p.id, p.title, d.content, p.pub_type
					FROM `documents` d JOIN `publication` p ON p.id = d.publication_id
					WHERE (MATCH(d.title) AGAINST ('$keywords' IN BOOLEAN MODE) OR MATCH(d.content) AGAINST ('$keywords' IN BOOLEAN MODE))
					$order_clause
					$limit";
			}
		}
		$res =& $this->db->query($sql);
		if (PEAR::isError($res))
			throw new SException($res->getMessage());
		$this->init_arrows($res->numRows(), $bulk, $page, $order_by);

		while ($row = $res->fetchRow())
		{
			$id = $row[0];
			$title = $row[1];
			$fulltext = stripslashes($row[2]);
			$pub_type = $row[3];
			$keywords_arr = explode(" ", str_replace('\"', '', $keywords));
			$title_higligthed = highlight_str(htmlspecialchars($title), $keywords_arr);
			$passages_highlighted = '';
			foreach ($keywords_arr as $keyword)
			{
				if (strlen(trim($keyword)) != 0)
				{
					$pos = stripos($fulltext, $keyword);
					if ($pos === false)
						continue;
					else
					{
						$space_to_end = strlen($fulltext)-$pos;
						$length = $space_to_end >= 50 ? 100 : $space_to_end;
						if ($pos < 50)
						{
							$start = 0;
							$passage = substr($fulltext, $start, $length);
						}
						else
						{
							$start = $pos - 50;
							$passage = substr($fulltext, $start, $length);
						}
						$passage = htmlspecialchars($passage);
						$i = -1;
						while ($passage[++$i] != ' ') {}
						$l = $j = strlen($passage);
						while ($passage[--$j] != ' ') {}
						$passage = substr($passage, $i, $j-$i);
						$keyword_san = htmlspecialchars(preg_quote($keyword));
						$passage_higligthed = eregi_replace("(.$keyword_san.)|(.$keyword_san$)|(^$keyword_san.)", " <strong>$keyword_san</strong> ", $passage);
						$passages_highlighted .= "$passage_higligthed... ";
					}
				}
			}
			$authors = get_authors($this->db, $id);
			$categories = get_categories($this->db, $id);
			$annot = annotation_tag($this->db, $id, $this->auth_module->get_id());
			$search_results[] = array(
			'id' => $id,
			'title' => $title_higligthed,
			'authors' => $authors,
			'passages' => $passages_highlighted,
			'pub_type' => $pub_type,
			'categories' => $categories,
			'annot' => $annot);
		}
		$this->smarty->assign('documents_results', $search_results);
		$this->smarty->display('user_publication_results.tpl');
	}


/**
	 * Display page containing a list of found publications. To each publication
	 * attach a piece of text where the matching phrase was found.  Search only in my publications
	 *
	 * @param string $keywords sanitized search keywords
	 * @param array $categories ids of selected categories
	 */
	private function display_search_results_document_my_publications($keywords, $categories)
	{
		$submitter_id=$this->auth_module->get_id();
		$_SESSION['search_qs'] = htmlentities($_SERVER['QUERY_STRING']); //save query string
		$this->db->setFetchMode(DB_FETCHMODE_ORDERED);

		$order_by = $this->get['order_by'];
		switch ($order_by)
		{
			case 'title':
				$order_clause = "ORDER BY p.title ASC";
				break;
			case 'date':
				$order_clause = "ORDER BY p.issue_date DESC, p.title ASC";
				break;
			default:
				$order_by = 'relevance';
				$order_clause = "ORDER BY 5 * MATCH(d.title) AGAINST ('$keywords') + MATCH(d.content) AGAINST ('$keywords') DESC";
		}

		$bulk = 20;
		$page = is_numeric($this->get['page']) ? $this->get['page'] : 0;
		$offset = $bulk * $page;
		$limit = " LIMIT $offset, $bulk";

		if (is_array($categories))
		{
			if ($this->get['operator'] == 'or')
			{ //operator between categories is 'OR'
				$cat_ids = ids_clause($categories);
				$sql = "SELECT DISTINCT p.id, p.title, d.content, p.pub_type
					FROM `documents` d
						JOIN `publication` p ON p.id = d.publication_id
						JOIN `categories_has_publication` c ON p.id = c.publication_id
					WHERE (MATCH(d.title) AGAINST ('$keywords' IN BOOLEAN MODE) OR MATCH(d.content) AGAINST ('$keywords' IN BOOLEAN MODE))
						AND c.categories_id IN ($cat_ids)
						AND p.id IN (SELECT publication_id from submitter_has_publication where submitter_id=$submitter_id)
					$order_clause
					$limit";
			}
			else
			{ //operator between categories is 'AND'
				$num_cat = count($categories);
				$where_clause = arr_condition($categories, 'categories_id');
				$sql = "SELECT p.id, p.title, d.content, p.pub_type
					FROM `documents` d
						JOIN `publication` p ON p.id = d.publication_id
					WHERE (MATCH(d.title) AGAINST ('$keywords' IN BOOLEAN MODE) OR MATCH(d.content) AGAINST ('$keywords' IN BOOLEAN MODE)) 
						AND p.id IN (
							SELECT publication_id
							FROM `categories_has_publication`
							WHERE $where_clause
							GROUP BY (publication_id)
							HAVING COUNT(publication_id) = '$num_cat'
						)
						AND p.id IN (SELECT publication_id from submitter_has_publication where submitter_id=$submitter_id)
					$order_clause
					$limit";
			}
		} else { //no categories selected
			if ($this->get['advanced'] != 'false') //advanced search is activated
			{
				$sql = "SELECT p.id, p.title, d.content, p.pub_type
					FROM `documents` d JOIN `publication` p ON p.id = d.publication_id
					WHERE (MATCH(d.title) AGAINST ('$keywords' IN BOOLEAN MODE) OR MATCH(d.content) AGAINST ('$keywords' IN BOOLEAN MODE))
						AND p.id NOT IN (
							SELECT publication_id
							FROM `categories_has_publication`
						)
						AND p.id IN (SELECT publication_id from submitter_has_publication where submitter_id=$submitter_id)
					$order_clause
					$limit";
			}
			else
			{
				$sql = "SELECT p.id, p.title, d.content, p.pub_type
					FROM `documents` d JOIN `publication` p ON p.id = d.publication_id
					WHERE ((MATCH(d.title) AGAINST ('$keywords' IN BOOLEAN MODE) OR MATCH(d.content) AGAINST ('$keywords' IN BOOLEAN MODE))
					AND p.id IN (SELECT publication_id from submitter_has_publication where submitter_id=$submitter_id))
					$order_clause
					$limit";
			}
		}
		$res =& $this->db->query($sql);
		if (PEAR::isError($res))
			throw new SException($res->getMessage());
		$this->init_arrows($res->numRows(), $bulk, $page, $order_by);

		while ($row = $res->fetchRow())
		{
			$id = $row[0];
			$title = $row[1];
			$fulltext = stripslashes($row[2]);
			$pub_type = $row[3];
			$keywords_arr = explode(" ", str_replace('\"', '', $keywords));
			$title_higligthed = highlight_str(htmlspecialchars($title), $keywords_arr);
			$passages_highlighted = '';
			foreach ($keywords_arr as $keyword)
			{
				if (strlen(trim($keyword)) != 0)
				{
					$pos = stripos($fulltext, $keyword);
					if ($pos === false)
						continue;
					else
					{
						$space_to_end = strlen($fulltext)-$pos;
						$length = $space_to_end >= 50 ? 100 : $space_to_end;
						if ($pos < 50)
						{
							$start = 0;
							$passage = substr($fulltext, $start, $length);
						}
						else
						{
							$start = $pos - 50;
							$passage = substr($fulltext, $start, $length);
						}
						$passage = htmlspecialchars($passage);
						$i = -1;
						while ($passage[++$i] != ' ') {}
						$l = $j = strlen($passage);
						while ($passage[--$j] != ' ') {}
						$passage = substr($passage, $i, $j-$i);
						$keyword_san = htmlspecialchars(preg_quote($keyword));
						$passage_higligthed = eregi_replace("(.$keyword_san.)|(.$keyword_san$)|(^$keyword_san.)", " <strong>$keyword_san</strong> ", $passage);
						$passages_highlighted .= "$passage_higligthed... ";
					}
				}
			}
			$authors = get_authors($this->db, $id);
			$categories = get_categories($this->db, $id);
			$annot = annotation_tag($this->db, $id, $this->auth_module->get_id());
			$search_results[] = array(
			'id' => $id,
			'title' => $title_higligthed,
			'authors' => $authors,
			'passages' => $passages_highlighted,
			'pub_type' => $pub_type,
			'categories' => $categories,
			'annot' => $annot);
		}
		$this->smarty->assign('documents_results', $search_results);
		$this->smarty->display('user_publication_results.tpl');
	}



	/**
	 * Displays publication previews by authors
	 *
	 * @param string $authors names of authors in raw style as given by the user input
	 * @param array $categories ids of selected categories
	 */
	private function display_search_results_author($authors, $categories)
	{
		$publication_title=$authors;
		$_SESSION['search_qs'] = $_SERVER['QUERY_STRING']; //save query string
		$authors = trim($authors);
		$authors = preg_replace('/\s{2,}/', ' ', $authors); //remove additional spaces
		$word_arr = split(' ', $authors);

		//order by
		$order_by = $this->get['order_by'];
		switch ($order_by)
		{
			case 'date':
				$order_clause = "ORDER BY p.issue_date DESC, p.title ASC";
				break;
			default:
				$order_by = 'title';
				$order_clause = "ORDER BY p.title ASC";
		}
		//limit
		$bulk = 20;
		$page = is_numeric($this->get['page']) ? $this->get['page'] : 0;
		$offset = $bulk * $page;
		$limit = " LIMIT $offset, $bulk";
		//conditions
		$conditions = '(';
		foreach ($word_arr as $w)
		{
			if (strlen($w) < 3 && $w!="and")//jump over abbreviations
				continue;
			$conditions .= "a.name like '%$w' or a.middlename like '%$w' or a.surname like '%$w' or ";
		}
		$conditions .= ' false)';

		if (is_array($categories))
		{
			if ($this->get['operator'] == 'or')
			{ //operator between categories is 'OR'
				$cat_ids = ids_clause($categories);
				$sql = "SELECT DISTINCT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
						JOIN `categories_has_publication` c ON p.id = c.publication_id
						JOIN author_has_publication ap ON p.id = ap.publication_id
						JOIN author a ON a.id = ap.author_id
					WHERE $conditions
						AND c.categories_id IN ($cat_ids)
					$order_clause
					$limit";

				$sql2 = "SELECT DISTINCT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
						JOIN `categories_has_publication` c ON p.id = c.publication_id
					WHERE p.title like '%$publication_title'
						AND c.categories_id IN ($cat_ids)
						$order_clause
					$limit";

			}
			else
			{ //operator between categories is 'AND'
				$num_cat = count($categories);
				$where_clause = arr_condition($categories, 'categories_id');
				$sql = "SELECT DISTINCT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
						JOIN author_has_publication ap ON p.id = ap.publication_id
						JOIN author a ON a.id = ap.author_id
					WHERE $conditions
						AND p.id IN (
							SELECT publication_id
							FROM `categories_has_publication`
							WHERE $where_clause
							GROUP BY (publication_id)
							HAVING COUNT(publication_id) = '$num_cat'
						)
					$order_clause
					$limit";

				$sql2 = "SELECT DISTINCT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
					WHERE p.title like '%$publication_title'
						AND p.id IN (
							SELECT publication_id
							FROM `categories_has_publication`
							WHERE $where_clause
							GROUP BY (publication_id)
							HAVING COUNT(publication_id) = '$num_cat'
						)
					$order_clause
					$limit";

			}
		} else { //no categories selected
			if ($this->get['advanced'] != 'false') //advanced search is activated
			{
				$sql = "SELECT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
						JOIN author_has_publication ap ON p.id = ap.publication_id
						JOIN author a ON a.id = ap.author_id
					WHERE $conditions
						AND p.id NOT IN (
							SELECT publication_id
							FROM `categories_has_publication`
						)
					$order_clause
					$limit";

				$sql2 = "SELECT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
					WHERE p.title like '%$publication_title'
						AND p.id NOT IN (
							SELECT publication_id
							FROM `categories_has_publication`
						)
					$order_clause
					$limit";
			}
			else
			{
				$sql = "SELECT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
						JOIN author_has_publication ap ON p.id = ap.publication_id
						JOIN author a ON a.id = ap.author_id
					WHERE $conditions
					$order_clause
					$limit";

				$sql2 = "SELECT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
					WHERE p.title like '%$publication_title'
					$order_clause
					$limit";

			}
		}
		$this->db->setFetchMode(DB_FETCHMODE_ASSOC);
		$res = $this->db->query($sql);
		$res2 = $this->db->query($sql2);
		if (PEAR::isError($res))
			throw new SException($res->getMessage());
		if (PEAR::isError($res2))
			throw new SException($res->getMessage());
		$this->init_arrows($res->numRows(), $bulk, $page, $order_by);
		$this->init_arrows($res2->numRows(), $bulk, $page, $order_by);


		//display found publications
		while ($row = $res->fetchRow())
		{
			$id = htmlspecialchars($row['id']);
			$submitter_id = htmlspecialchars($row['submitter_id']);
			$title = htmlspecialchars($row['title']);
			$abstract = htmlspecialchars($row['abstract']);
			$authors = highlight_str(get_authors($this->db, $id), $word_arr);
			$categories = get_categories($this->db, $id);
			$type_name = $row['pub_type'];
			$publications[] = "<a href=\"?pid=$id\">$title</a> ".annotation_tag($this->db, $id, $submitter_id)." ($type_name)<br />
				Authors: $authors<br />
				<span class=\"categories_strip\">Categories: $categories</span>";
		}
		while($row2 = $res2->fetchRow()){
			$id = htmlspecialchars($row2['id']);
			$submitter_id = htmlspecialchars($row2['submitter_id']);
			$title = htmlspecialchars($row2['title']);
			$abstract = htmlspecialchars($row2['abstract']);
			$authors = highlight_str(get_authors($this->db, $id), $word_arr);
			$categories = get_categories($this->db, $id);
			$type_name = $row2['pub_type'];
			$publications2[] = "<a href=\"?pid=$id\">$title</a> ".annotation_tag($this->db, $id, $submitter_id)." ($type_name)<br />
				Authors: $authors<br />
				<span class=\"categories_strip\">Categories: $categories</span>";
		}


		$this->smarty->assign('authors_results', $publications);
		$this->smarty->assign('authors_results2', $publications2);

		$this->smarty->assign('authors', $this->get['authors']);
		$this->smarty->display('user_author_results.tpl');
	}

/**
	 * Displays publication previews by authors. Search only in my publications
	 *
	 * @param string $authors names of authors in raw style as given by the user input
	 * @param array $categories ids of selected categories
	 */
	private function display_search_results_author_my_publications($authors, $categories)
	{
		$publication_title=$authors;
		$submitter_id=$this->auth_module->get_id();
		$_SESSION['search_qs'] = $_SERVER['QUERY_STRING']; //save query string
		$authors = trim($authors);
		$authors = preg_replace('/\s{2,}/', ' ', $authors); //remove additional spaces
		$word_arr = split(' ', $authors);

		//order by
		$order_by = $this->get['order_by'];
		switch ($order_by)
		{
			case 'date':
				$order_clause = "ORDER BY p.issue_date DESC, p.title ASC";
				break;
			default:
				$order_by = 'title';
				$order_clause = "ORDER BY p.title ASC";
		}
		//limit
		$bulk = 20;
		$page = is_numeric($this->get['page']) ? $this->get['page'] : 0;
		$offset = $bulk * $page;
		$limit = " LIMIT $offset, $bulk";
		//conditions
		$conditions = '(';
		foreach ($word_arr as $w)
		{
			if (strlen($w) < 3)//jump over abbreviations
				continue;
			$conditions .= "a.name like '%$w' or a.middlename like '%$w' or a.surname like '%$w' or ";
		}
		$conditions .= ' false)';

		if (is_array($categories))
		{
			if ($this->get['operator'] == 'or')
			{ //operator between categories is 'OR'
				$cat_ids = ids_clause($categories);
				$sql = "SELECT DISTINCT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
						JOIN `categories_has_publication` c ON p.id = c.publication_id
						JOIN author_has_publication ap ON p.id = ap.publication_id
						JOIN author a ON a.id = ap.author_id
					WHERE $conditions
						AND c.categories_id IN ($cat_ids)
						AND p.id IN (SELECT publication_id from submitter_has_publication where submitter_id=$submitter_id)
					$order_clause
					$limit";

				$sql2 = "SELECT DISTINCT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
						JOIN `categories_has_publication` c ON p.id = c.publication_id
					WHERE p.title like '%$publication_title'
						AND c.categories_id IN ($cat_ids)
						AND p.id IN (SELECT publication_id from submitter_has_publication where submitter_id=$submitter_id)
					$order_clause
					$limit";


			}
			else
			{ //operator between categories is 'AND'
				$num_cat = count($categories);
				$where_clause = arr_condition($categories, 'categories_id');
				$sql = "SELECT DISTINCT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
						JOIN author_has_publication ap ON p.id = ap.publication_id
						JOIN author a ON a.id = ap.author_id
					WHERE $conditions
						AND p.id IN (
							SELECT publication_id
							FROM `categories_has_publication`
							WHERE $where_clause
							GROUP BY (publication_id)
							HAVING COUNT(publication_id) = '$num_cat'
						)
						AND p.id IN (SELECT publication_id from submitter_has_publication where submitter_id=$submitter_id)
					$order_clause
					$limit";

				$sql2 = "SELECT DISTINCT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
					WHERE p.title like '%$publication_title'
						AND p.id IN (
							SELECT publication_id
							FROM `categories_has_publication`
							WHERE $where_clause
							GROUP BY (publication_id)
							HAVING COUNT(publication_id) = '$num_cat'
						)
						AND p.id IN (SELECT publication_id from submitter_has_publication where submitter_id=$submitter_id)
					$order_clause
					$limit";


			}
		} else { //no categories selected
			if ($this->get['advanced'] != 'false') //advanced search is activated
			{
				$sql = "SELECT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
						JOIN author_has_publication ap ON p.id = ap.publication_id
						JOIN author a ON a.id = ap.author_id
					WHERE $conditions
						AND p.id NOT IN (
							SELECT publication_id
							FROM `categories_has_publication`
						)
						AND p.id IN (SELECT publication_id from submitter_has_publication where submitter_id=$submitter_id)
					$order_clause
					$limit";

				$sql2 = "SELECT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
					WHERE p.title like '%$publication_title'
						AND p.id NOT IN (
							SELECT publication_id
							FROM `categories_has_publication`
						)
						AND p.id IN (SELECT publication_id from submitter_has_publication where submitter_id=$submitter_id)
					$order_clause
					$limit";

			}
			else
			{
				$sql = "SELECT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
						JOIN author_has_publication ap ON p.id = ap.publication_id
						JOIN author a ON a.id = ap.author_id
					WHERE $conditions
					AND p.id IN (SELECT publication_id from submitter_has_publication where submitter_id=$submitter_id)
					$order_clause
					$limit";

				$sql2 = "SELECT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
					WHERE p.title like '%$publication_title'
					AND p.id IN (SELECT publication_id from submitter_has_publication where submitter_id=$submitter_id)
					$order_clause
					$limit";
			}



		}
		$this->db->setFetchMode(DB_FETCHMODE_ASSOC);
		$res = $this->db->query($sql);
		$res2 = $this->db->query($sql2);
		if (PEAR::isError($res))
			throw new SException($res->getMessage());
		if (PEAR::isError($res2))
			throw new SException($res->getMessage());
		$this->init_arrows($res->numRows(), $bulk, $page, $order_by);
		$this->init_arrows($res2->numRows(), $bulk, $page, $order_by);

		//display found publications
		while ($row = $res->fetchRow())
		{
			$id = htmlspecialchars($row['id']);
			$submitter_id = htmlspecialchars($row['submitter_id']);
			$title = htmlspecialchars($row['title']);
			$abstract = htmlspecialchars($row['abstract']);
			$authors = highlight_str(get_authors($this->db, $id), $word_arr);
			$categories = get_categories($this->db, $id);
			$type_name = $row['pub_type'];
			$publications[] = "<a href=\"?pid=$id\">$title</a> ".annotation_tag($this->db, $id, $submitter_id)." ($type_name)<br />
				Authors: $authors<br />
				<span class=\"categories_strip\">Categories: $categories</span>";
		}
		while($row2 = $res2->fetchRow()){
			$id = htmlspecialchars($row2['id']);
			$submitter_id = htmlspecialchars($row2['submitter_id']);
			$title = htmlspecialchars($row2['title']);
			$abstract = htmlspecialchars($row2['abstract']);
			$authors = highlight_str(get_authors($this->db, $id), $word_arr);
			$categories = get_categories($this->db, $id);
			$type_name = $row2['pub_type'];
			$publications2[] = "<a href=\"?pid=$id\">$title</a> ".annotation_tag($this->db, $id, $submitter_id)." ($type_name)<br />
				Authors: $authors<br />
				<span class=\"categories_strip\">Categories: $categories</span>";
		}
		$this->smarty->assign('authors_results', $publications);
		$this->smarty->assign('authors_results2', $publications2);
		$this->smarty->assign('authors', $this->get['authors']);
		$this->smarty->display('user_author_results.tpl');
	}


	/**
	 * Display page containing a list of found publications. Regarding
	 * to selected categories.
	 *
	 * @param array $categories ids of selected categories
	 */
	private function display_search_results_categories($categories)
	{
		$_SESSION['search_qs'] = $_SERVER['QUERY_STRING']; //save query string
		$this->db->setFetchMode(DB_FETCHMODE_ORDERED);

		$order_by = $this->get['order_by'];
		switch ($order_by)
		{
			case 'date':
				$order_clause = "ORDER BY p.issue_date DESC, p.title ASC";
				break;
			default:
				$order_by = 'title';
				$order_clause = "ORDER BY p.title ASC";
		}
		//limit
		$bulk = 20;
		$page = is_numeric($this->get['page']) ? $this->get['page'] : 0;
		$offset = $bulk * $page;
		$limit = " LIMIT $offset, $bulk";
		if (is_array($categories))
		{
			if ($this->get['operator'] == 'or')
			{ //operator between categories is 'OR'
				$cat_ids = ids_clause($categories);
				$sql = "SELECT DISTINCT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
						JOIN `categories_has_publication` c ON p.id = c.publication_id
					WHERE c.categories_id IN ($cat_ids)
					$order_clause
					$limit";
			}
			else
			{ //operator between categories is 'AND'
				$num_cat = count($categories);
				$where_clause = arr_condition($categories, 'categories_id');
				$sql = "SELECT DISTINCT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
					WHERE p.id IN (
							SELECT publication_id
							FROM `categories_has_publication`
							WHERE $where_clause
							GROUP BY (publication_id)
							HAVING COUNT(publication_id) = '$num_cat'
						)
					$order_clause
					$limit";
			}
		} else
			throw new SException("Categories are empty.");
		$this->db->setFetchMode(DB_FETCHMODE_ASSOC);
		$res = $this->db->query($sql);
		if (PEAR::isError($res))
			throw new SException($res->getMessage());
		$this->init_arrows($res->numRows(), $bulk, $page, $order_by);
		//display found publications
		while ($row = $res->fetchRow())
		{
			$id = htmlspecialchars($row['id']);
			$submitter_id = htmlspecialchars($row['submitter_id']);
			$title = htmlspecialchars($row['title']);
			$abstract = htmlspecialchars($row['abstract']);
			$authors = get_authors($this->db, $id);
			$categories = get_categories($this->db, $id);
			$type_name = $row['pub_type'];
			$publications[] = "<a href=\"?pid=$id\">$title</a> ".annotation_tag($this->db, $id, $submitter_id)." ($type_name)<br />
				Authors: $authors<br />
				<span class=\"categories_strip\">Categories: $categories</span>";
		}
		$this->smarty->assign('authors_results', $publications);
		$this->smarty->assign('authors', $this->get['authors']);
		$this->smarty->display('user_publication_results.tpl');
	}

/**
	 * Display page containing a list of found publications. Regarding
	 * to selected categories.  Search only in my publications
	 *
	 * @param array $categories ids of selected categories
	 */
	private function display_search_results_categories_my_publications($categories)
	{
		$submitter_id=$this->auth_module->get_id();
		$_SESSION['search_qs'] = $_SERVER['QUERY_STRING']; //save query string
		$this->db->setFetchMode(DB_FETCHMODE_ORDERED);

		$order_by = $this->get['order_by'];
		switch ($order_by)
		{
			case 'date':
				$order_clause = "ORDER BY p.issue_date DESC, p.title ASC";
				break;
			default:
				$order_by = 'title';
				$order_clause = "ORDER BY p.title ASC";
		}
		//limit
		$bulk = 20;
		$page = is_numeric($this->get['page']) ? $this->get['page'] : 0;
		$offset = $bulk * $page;
		$limit = " LIMIT $offset, $bulk";
		if (is_array($categories))
		{
			if ($this->get['operator'] == 'or')
			{ //operator between categories is 'OR'
				$cat_ids = ids_clause($categories);
				$sql = "SELECT DISTINCT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
						JOIN `categories_has_publication` c ON p.id = c.publication_id
					WHERE c.categories_id IN ($cat_ids)
					AND p.id IN (SELECT publication_id from submitter_has_publication where submitter_id=$submitter_id)
					$order_clause
					$limit";
			}
			else
			{ //operator between categories is 'AND'
				$num_cat = count($categories);
				$where_clause = arr_condition($categories, 'categories_id');
				$sql = "SELECT DISTINCT p.id, p.pub_type, p.title, p.submitter_id
					FROM `publication` p
					WHERE p.id IN (
							SELECT publication_id
							FROM `categories_has_publication`
							WHERE $where_clause
							GROUP BY (publication_id)
							HAVING COUNT(publication_id) = '$num_cat'
						)
						AND p.id IN (SELECT publication_id from submitter_has_publication where submitter_id=$submitter_id)
					$order_clause
					$limit";
			}
		} else
			throw new SException("Categories are empty.");
		$this->db->setFetchMode(DB_FETCHMODE_ASSOC);
		$res = $this->db->query($sql);
		if (PEAR::isError($res))
			throw new SException($res->getMessage());
		$this->init_arrows($res->numRows(), $bulk, $page, $order_by);
		//display found publications
		while ($row = $res->fetchRow())
		{
			$id = htmlspecialchars($row['id']);
			$submitter_id = htmlspecialchars($row['submitter_id']);
			$title = htmlspecialchars($row['title']);
			$abstract = htmlspecialchars($row['abstract']);
			$authors = get_authors($this->db, $id);
			$categories = get_categories($this->db, $id);
			$type_name = $row['pub_type'];
			$publications[] = "<a href=\"?pid=$id\">$title</a> ".annotation_tag($this->db, $id, $submitter_id)." ($type_name)<br />
				Authors: $authors<br />
				<span class=\"categories_strip\">Categories: $categories</span>";
		}
		$this->smarty->assign('authors_results', $publications);
		$this->smarty->assign('authors', $this->get['authors']);
		$this->smarty->display('user_publication_results.tpl');
	}



	/**
	 * Initialize publication subheader
	 *
	 * @param int $publication_id
	 * @param array $publ_data associative array of BibTeX fields
	 */
	private function init_publication_subheader($publication_id, $publ_data)
	{
		$this->smarty->assign('logged_info', $this->auth_module->get_login());
		$this->smarty->assign('title_label', $publ_data['title']);
		//categories
		$categories = get_categories($this->db, $publication_id);
		$this->smarty->assign('categories_label', $categories);
		//authors
		$authors = get_authors($this->db, $publication_id, $author_surnames); //we need to get author surnames
		$this->smarty->assign('authors_label', $authors);
		$this->smarty->assign('author_surnames', $author_surnames);
	}


	/**
	 * Display page containing info about a publication
	 *
	 * @param int $publication_id id of publication
	 */
	private function display_publication($publication_id)
	{
		$this->choose_format();
		$format = $this->db->getAssoc('SELECT id, name FROM `format` ORDER BY name');
		$this->smarty->assign('format', $format);
		$this->smarty->assign('selected_format', $_SESSION['selected_format']);

		$publ_data = get_all_publication_data($this->db, $publication_id);

		//initialize subheader
		$this->init_publication_subheader($publication_id, $publ_data);
		//create list of filelds
		foreach ($publ_data as $i => $v)
			$this->smarty->assign($i, $v);
		//create BibTeX definition
		$bibtex = Bibtex::create($publ_data['pub_type']);
		$helping_authors = get_authors($this->db, $publication_id, $as, $aar, ' and '); //define custom ' and ' separator for bibtex
		$helping_publ_data = array_diff_key($publ_data, array('author'=>0));
		$helping_publ_data = array_merge($helping_publ_data, array('author' => $helping_authors));
		$this->smarty->assign('bibtex', $bibtex->get_bibtex($helping_publ_data));
		//create citation
		$generator = new CitGenerator($this->db);
		$citation = $generator->get_citation($publ_data, $publication_id, $_SESSION['selected_format']);
		$this->smarty->assign('citation', $citation);
		//files
		$doc_provider = new DocumentProvider($this->db);
		$files = $doc_provider->get_file_links($publication_id);
		$this->smarty->assign('files', $files);

		$this->smarty->assign('tab', 'overview');
		$this->smarty->display('user_publ.tpl');
	}

	/**
	 * Displays page containing form allowing the user to make modifications
	 * of the publication
	 *
	 * @param int $publication_id
	 */
	private function display_modify_publication($publication_id)
	{
		$publ_data = get_all_publication_data($this->db, $publication_id);
		//init subheader
		$this->init_publication_subheader($publication_id, $publ_data);
		$this->admin->fill_modify_form($publication_id);

		$this->smarty->assign('tab', 'modify');
		$this->smarty->display('user_publ.tpl');
	}

	/**
	 * Displays page containing global and private publication annotations
	 *
	 * @param int $publication_id
	 */
	private function display_annotations($publication_id)
	{
		$publ_data = get_all_publication_data($this->db, $publication_id);

		//init subheader
		$this->init_publication_subheader($publication_id, $publ_data);
		//annotations
		$this->db->setFetchMode(DB_FETCHMODE_ASSOC);
		if (!$this->auth_module->is_admin())
		{
			$editable_annot = $this->db->getAll("SELECT a.*, s.name as owner FROM
				`annotation` a JOIN `submitter` s ON a.submitter_id = s.id
				WHERE publication_id = ? AND submitter_id = ?", array($publication_id, $this->auth_module->get_id()));
			if (PEAR::isError($editable_annot))
				throw new SException($editable_annot->getMessage());
			$other_annot = $this->db->getAll("SELECT a.*, s.name as owner FROM
				`annotation` a JOIN `submitter` s ON a.submitter_id = s.id
				WHERE global_scope = 1 AND publication_id = ?
				AND submitter_id <> ?", array($publication_id, $this->auth_module->get_id()));
			if (PEAR::isError($other_annot))
				throw new SException($other_annot->getMessage());
			$this->smarty->assign('editable_annot', htmlspecialchars_rec($editable_annot));
			$this->smarty->assign('other_annot', htmlspecialchars_rec($other_annot));
		}
		else //if current user is admin, allow all modifications
		{
			$editable_annot = $this->db->getAll("SELECT a.*, s.name as owner FROM
				`annotation` a JOIN `submitter` s ON a.submitter_id = s.id
				WHERE publication_id = '$publication_id'");
			if (PEAR::isError($editable_annot))
				throw new SException($editable_annot->getMessage());
			$this->smarty->assign('editable_annot', htmlspecialchars_rec($editable_annot));
		}

		$this->smarty->assign('tab', 'annotations');
		$this->smarty->display('user_publ.tpl');
	}

	/**
	 * Displays empty page with searchbar
	 *
	 */
	private function display_front_page()
	{
		$this->smarty->display('user_front.tpl');
	}

}


?>