<?php

/**
* Class for handling ajax requests in modify publication form.
* Handles requests for details of publisher, conference and journal.
*
*/
class AjaxDetailHandler
{
	private $db;
	private $request;
	private $auth_module;

	/**
	 * Constructor
	 *
	 * @param PEAR::DB $db
	 */
	public function __construct(&$db, $request)
	{
		$this->db = $db;
		$this->request = $request;
		$this->auth_module = new AuthModule($db);
	}

	/**
	 * Handles ajax request (id of a particular record given by GET method). The result
	 * of this operation is a javascript array writen to the output.
	 *
	 */
	public function handle_request()
	{
		$publication_id = $this->request['pid'];
		$publisher_id = $this->request['publisher'];
		$conference2_id = $this->request['conference2'];
		$conference_year_id = $this->request['conference_year'];
		$journal_id = $this->request['journal'];
		$author_id = $this->request['author'];

		if (is_numeric($publisher_id))
		{
			$row = $this->db->getRow("SELECT name, address FROM `publisher` WHERE id=?", array($publisher_id), DB_FETCHMODE_ASSOC);
			if (PEAR::isError($row))
    			die($row->getMessage());
    			$used = $this->db->getOne("SELECT count(*)
    			FROM `publication`
    			WHERE publisher_id=?", $publisher_id);
			$puid = $this->db->getOne("SELECT publisher_id FROM publication WHERE id='$publication_id'");
			if (PEAR::isError($puid))
				throw new Exception($puid->getMessage());
			if ($used == 0 || ($used == 1 && $puid == $publisher_id))
				$forbidden = 0; //allow
			else
				$forbidden = 1;
    		$jsarr = 'Array("'.$forbidden.'", "'.$row['name'].'", "'.$row['address'].'")';
    		echo($jsarr);
		}


		elseif (is_numeric($author_id))
		{
			$row = $this->db->getRow("SELECT name, middle_name, surname
				FROM `author` WHERE id=?", array($author_id), DB_FETCHMODE_ORDERED);
			if (PEAR::isError($row))
    			die($row->getMessage());
			$used = $this->db->getOne("SELECT count(*) FROM `publication`
    			WHERE author_id=?", $author_id);
			$aid = $this->db->getOne("SELECT author_id FROM publication WHERE id='$author_id'");
			if (PEAR::isError($aid))
				throw new Exception($puid->getMessage());
			if ($used == 0 || ($used == 1 && $aid == $author_id))
				$forbidden = 0; //allow
			else
				$forbidden = 1;
    		$jsarr = 'Array("'.$forbidden.'", "'.$row[0].'", "'.$row[1].'", "'.$row[2].'")';
    		echo($jsarr);
		}


		elseif (is_numeric($conference2_id))
		{
			$row = $this->db->getRow("SELECT name, abbreviation, description, first_year
				FROM `conference2` WHERE id=?", array($conference2_id), DB_FETCHMODE_ORDERED);

			if (PEAR::isError($row))
    			die($row->getMessage());

			$row2 = $this->db->getAll("SELECT id, w_year, name
				FROM `conference_year` WHERE conference2_id=? order by w_year", array($conference2_id), DB_FETCHMODE_ORDERED);

			if (PEAR::isError($row2))
    			die($row2->getMessage());

			$row2_count = $this->db->getOne("SELECT count(*) 
				FROM `conference_year` WHERE conference2_id=?", $conference2_id);

			if (PEAR::isError($row2_count))
    			die($row2_count->getMessage());

			$allowed = check_conference2_editability($this->db, $conference2_id, $this->auth_module->get_id(), $publication_id);

    		//$jsarr = 'Array("'.$allowed.'", "'.$row[0].'", "'.$row[1].'", "'.$row[2].'", "'.$row[3].'", "'.$row2[0][0].'", "'.$row2[0][1].'", "'.$row2[1][0].'", "'.$row2[1][1].'", "'.$row2[2][0].'", "'.$row2[2][1].'")';
		//$jsarr = 'Array("'.$allowed.'", "'.$row[0].'", "'.$row[1].'", "'.$row[2].'", "'.$row[3].'", "'.$row2[0][0].'", "'.$row2[0][1].'", "'.$row2[1][0].'", "'.$row2[1][1].'", "'.$row2[2][0].'", "'.$row2[2][1].'", "'.$row2_count.'")';
		//$jsarr = 'Array("'.$allowed.'", "'.$row[0].'", "'.$row[1].'", "'.$row[2].'", "'.$row[3].'", "'.$row2_count.'", "'.$row2[0][0].'", "'.$row2[0][1].'", "'.$row2[1][0].'", "'.$row2[1][1].'", "'.$row2[2][0].'", "'.$row2[2][1].'")';
		
		$jsarr = 'Array("'.$allowed.'", "'.$row[0].'", "'.$row[1].'", "'.$row[2].'", "'.$row[3].'")';
		$x = '||';
		$jsarr2='';
		

		for($i=0; $i<$row2_count;$i++){

			$jsarr2=$jsarr2.$row2[$i][0].'*'.$row2[$i][1].'*'.$row2[$i][2];
			if($i!=$row2_count-1)
			{
				$jsarr2=$jsarr2.'|';
			}


		}

		if(!$row2_count){
			 $jsarr2=$jsarr2.'<option></option>';
		}

		$a1='<select name="conference_year" id="conference_year_sel" size="10" value="{$conference_year_sel}" >';
		$a2='</select>';

		$jsarr=$jsarr.$x.$jsarr2;

		
    		echo($jsarr);
		}


		elseif (is_numeric($conference_year_id))
		{
			$row = $this->db->getRow("SELECT name, w_year, w_from, w_to, location, isbn, description, publisher_id
				FROM `conference_year` WHERE id=?", array($conference_year_id), DB_FETCHMODE_ORDERED);
			if (PEAR::isError($row))
    			die($row->getMessage());
			$allowed = check_conference_year_editability($this->db, $conference_year_id, $this->auth_module->get_id(), $publication_id);
    		$jsarr = 'Array("'.$allowed.'", "'.$row[0].'", "'.$row[1].'", "'.$row[2].'", "'.$row[3].'", "'.$row[4].'", "'.$row[5].'", "'.$row[6].'", "'.$row[7].'")';
    		echo($jsarr);
		}

		elseif (is_numeric($journal_id))
		{
			$row = $this->db->getRow("SELECT name, issn
				FROM `journal` WHERE id=?", array($journal_id), DB_FETCHMODE_ORDERED);
			if (PEAR::isError($row))
    			die($row->getMessage());
    		$used = $this->db->getOne("SELECT count(*)
    			FROM `publication`
    			WHERE journal_id=?", $journal_id);
			$jid = $this->db->getOne("SELECT journal_id FROM publication WHERE id='$publication_id'");
			if (PEAR::isError($cid))
				throw new Exception($jid->getMessage());
			if ($used == 0 || ($used == 1 && $jid == $journal_id))
				$forbidden = 0; //allow
			else
				$forbidden = 1;
			$jsarr = 'Array("'.$forbidden.'", "'.$row[0].'", "'.$row[1].'")';
    		echo($jsarr);
		}
	}
}

?>