<?php
require_once('Contents.inc.php');

final class Contents_categories extends Contents {

	/**
	 * Execute contents tab 5
	 *
	 */
	public function execute() {
		include '../help/Help.php';
		if ($this->post['add_category']) {
			try {
				$this->add_category($this->post['new_category_name']);
				$this->smarty->assign('operation_success', 'The category has been added.');
				$this->display_categories_list();
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
				$this->display_categories_list();
			}
		} elseif ($ea=$this->post['edit_category']) {//$ea is array with only one element in format: $categories_id => "změnit"
			try {
				if(is_array($ea)) foreach($ea as $categories_id => $v) {
					$this->display_edit_category($categories_id);
				}
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				die($e->getMessage());
			}
		}
		elseif ($ea=$this->post['display_publications']) {
			try {
				if(is_array($ea)) foreach($ea as $categories_id => $v) {
					//$_SESSION["categories_id"] = $categories_id;

					$this->display_publications($categories_id);
				}
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				die($e->getMessage());
			}
		}
		elseif ($this->post['delete_files'] && $this->get['pid']){
			try {
				$this->delete_files($this->get['pid']);
				$this->smarty->assign('operation_success', 'Files has been deleted.');
				$this->display_overview($this->get['pid']);
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
				$this->display_overview($this->get['pid']);
			}
		} elseif ($this->post['add_file'] && $this->get['pid']) {
			try {
				$this->add_file($this->get['pid']);
				$this->smarty->assign('operation_success', 'File has been added.');
				$this->display_overview($this->get['pid']);
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
				$this->display_overview($this->get['pid']);
			}
		}
		elseif ($ea=$this->post['overview']) {
			try {
				if(is_array($ea)) foreach($ea as $publication_id => $v) {
					$this->display_overview($publication_id);
				}
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				die($e->getMessage());
			}
		}
		 elseif ($this->post['save_edited_category']) {
			try {
				$this->save_category($this->post['categories_id'], $this->post['name']);
				$this->smarty->assign('operation_success', 'Changes have been saved.');
				$this->smarty->assign('refresh', '1 ; URL=index.php?tab=5');
				$this->smarty->display('contents_categories.tpl');
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
				$this->display_edit_category($this->post['categories_id']);
			}
		} elseif ($da=$this->post['delete_category']) {//$da is array with only one element in format: ? => $categories_id
			try {
				if(is_array($da)) foreach($da as $categories_id => $v) {
					$this->delete_category($categories_id);
					$this->smarty->assign('operation_success', 'Category has beed deleted.');
					$this->display_categories_list();
				}
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
			}
		} 
		
		else {
			$this->display_categories_list();
		}

		

	}

	/**
	 * Show list of categories
	 *
	 */
	private function display_categories_list() {
		switch($this->get['order']) {
			case(1): $order_by = "ORDER BY name"; break;
			default: $order_by = "ORDER BY name";
		}
		$sql = "SELECT DISTINCT id, name
				FROM `categories` ".$order_by;
		$sql_sec = "
				SELECT categories_id
				FROM `categories_has_publication`
				GROUP BY categories_id
				HAVING COUNT(categories_id) > 0";
		$categories = $this->db->getAll($sql, array(), DB_FETCHMODE_ASSOC);
		$warning = $this->db->getAll($sql_sec, array(), DB_FETCHMODE_ORDERED);
		if (is_array($categories)) foreach ($categories as $i => $v) { //assign warnings
			if (in_array(array(0 => $v['id']), $warning))
				$categories[$i]['warning'] = 1;
		}
		$this->smarty->assign('show_categories', 1);
		$this->smarty->assign('categories', $categories);
		$this->smarty->display('contents_categories.tpl');
	}
	/**
	 * Display choose form of publications
	 *
	 * 
	 */
	private function display_publications($categories_id) {

		$sql = "SELECT id, title, submitter_id, pub_type
				FROM `publication`
				WHERE id IN
				(SELECT publication_id from categories_has_publication where categories_id = $categories_id) order by title";

		$publications = $this->db->getAll($sql, array(), DB_FETCHMODE_ASSOC);

		$this->smarty->assign('display_publications', 1);
		$this->smarty->assign('publications', $publications);
		$this->smarty->display('contents_categories.tpl');

	}

	public function display_overview($publication_id)
	{
		$data = get_all_publication_data($this->db, $publication_id);
		$date_arr = explode('-', $data['issue_date']);
		foreach ($data as $i => $v)
		{
			$this->smarty->assign($i, $v);
		}

		//attributes
		$sql = "SELECT DISTINCT id, name, description, confirmed
				FROM `attrib_storage` JOIN `attributes`
				ON attrib_storage.attributes_id=attributes.id
				WHERE attrib_storage.publication_id = '$publication_id'";
		$attributes = $this->db->getAll($sql, array(), DB_FETCHMODE_ASSOC);
		if (PEAR::isError($attributes)) {
			throw new Exception($attributes->getMessage());
		}
		$s = '';
		if (is_array($attributes))
		foreach ($attributes as $arr)
		{
			$s .=
			'<tr>
				<td><input type="checkbox" name="propagated_attributes[]" value="'.$arr['id'].'" '.($arr['confirmed']?'checked="checked" disabled="disabled"':'').' /></td>
				<td><strong>'.$arr['name'].'</strong></td>'.'
				<td>'.htmlspecialchars($arr['description']).'</td>'.'
				<td>'.htmlspecialchars($this->db->getOne("SELECT value FROM `attrib_storage` WHERE attributes_id='".$arr['id']."' AND publication_id='$publication_id'")).'</td>
			</tr>';
		}
		$this->smarty->assign('attributes', $s);

		$user_name = $this->db->getOne("SELECT name FROM `submitter` WHERE id=?", $data['submitter_id']);
		$user_surname = $this->db->getOne("SELECT surname FROM `submitter` WHERE id=?", $data['submitter_id']);
		if (PEAR::isError($user_name))
			throw new SAException($user_name->getMessage());
		if (PEAR::isError($user_surname))
			throw new SAException($user_surname->getMessage());
		$this->smarty->assign('user_name', $user_name);
		$this->smarty->assign('user_surname', $user_surname);

		//issue_date
		$issue_date_a = $this->db->getOne("SELECT issue_date FROM `publication` WHERE id=$publication_id");
		$issue_date_a=substr($issue_date_a,0, 7);
		$this->smarty->assign('issue_date_a', $issue_date_a);


		$publisher=$data['publisher_id'];
		$publisher_address = $this->db->getOne("SELECT address FROM `publisher` WHERE id=?", $data['publisher_id']);
		$this->smarty->assign('publisher_address', $publisher_address);


		$conference_year_id=$data['conference_year_id'];	
		$journal_id=$data['journal_id'];	

		$authors = get_authors($this->db, $publication_id);
		$categories = get_categories($this->db, $publication_id);
		$conference_year= get_conference_year_data($this->db, $conference_year_id);
		$conference2= get_conference2_data($this->db, $conference_year_id);
		$journal= get_journal_data($this->db, $journal_id);


		$this->smarty->assign('short_look', 1); //determine which part of template to use
		$this->smarty->assign('pid', $publication_id);
		$this->smarty->assign('title', $data['title']);
		$this->smarty->assign('booktitle', $data['booktitle']);
		$this->smarty->assign('pages', $data['pages']);
		$this->smarty->assign('pub_type', $data['pub_type']);
		$this->smarty->assign('isbn', $data['isbn']);

		$dp = new DocumentProvider($this->db, true);
		$files = $dp->get_file_links($publication_id);
		$this->smarty->assign('attached_files', $files);

		$this->smarty->assign('authors', $authors);
		$this->smarty->assign('categories', $categories);
		$this->smarty->assign('conference_year', $conference_year['conference_year']);
		$this->smarty->assign('conference2', $conference2['conference2']);
		$this->smarty->assign('journal', $journal['journal']);
		$this->smarty->assign('issn', $journal['issn']);

		$this->smarty->assign('tab', 5);

		$submitter_id=$this->auth_module->get_id();
		$publ_count = $this->db->getOne("SELECT COUNT(*) FROM `submitter_has_publication` WHERE publication_id=$publication_id AND submitter_id!=$submitter_id");
		$this->smarty->assign('publ_count', $publ_count);


		$this->smarty->display('contents_categories.tpl');

	}



	/**
	 * Display edit form of the category
	 *
	 * @param int $categories_id
	 */
	private function display_edit_category($categories_id) {
		$sql = "SELECT DISTINCT id, name
				FROM `categories`
				WHERE id='$categories_id'";
		$data =& $this->db->getRow($sql, array(), DB_FETCHMODE_ASSOC);
		if (PEAR::isError($data)) {
    		throw new SAException($data->getMessage());
		}
		$this->smarty->assign('edit_category', 1); //determine which part of template to use
		$this->smarty->assign('categories_id', $categories_id);
		$this->smarty->assign('name', $data['name']);
		$this->smarty->display('contents_categories.tpl');
	}

	/**
	 * Update name and description of any category identified by id
	 *
	 * @param int $categories_id
	 * @param string $new_name
	 */
	private function save_category($categories_id, $new_name) {
		if (sizeof($new_name) > 40)
			throw new Exception('Maximal length of category name is 40 characters.');
		if ($this->db->getOne("SELECT id FROM `categories` WHERE name='$new_name' AND id<>'$categories_id'"))
			throw new Exception('Category '.$new_name.' already exists.');
		$submitter_id = $this->auth_module->get_id();
		$res =& $this->db->query("UPDATE `categories` SET
		name='$new_name' ,
		submitter_id='$submitter_id'
		WHERE id='$categories_id'");
		if (PEAR::isError($res)) {
    		throw new SAException($res->getMessage());
		}
	}

	/**
	 * Delete category
	 *
	 * @param int $categories_id
	 */
	private function delete_category($categories_id) {
		$this->db->autoCommit(false);
		/* Uncomment this code only if you are not using DELETE CASCADE refference definition
		$res =& $this->db->query("DELETE FROM `categories_has_publication` WHERE categories_id='$categories_id'");
		if(PEAR::isError($res)) {
			$this->db->rollBack();
			throw new SAException($res->getMessage);
		}*/
		$res =& $this->db->query("DELETE FROM `categories` WHERE id='$categories_id'");
		if(PEAR::isError($res)) {
			$this->db->rollBack();
			throw new SAException($res->getMessage);
		}
		$this->db->commit();
	}


	/**
	 * Add new category into the database
	 *
	 * @param string $name
	 */
	private function add_category($name) {
		if (sizeof($name) > 40)
			throw new Exception('Maximal length of category name is 40 characters.');
		$submitter_id = $this->auth_module->get_id();;
		//is there the same category in the database?
		if ($this->db->getOne("SELECT id FROM `categories` WHERE name='$name'"))
			throw new Exception('Category '.$name.' already exists.');
		$sql = "INSERT INTO `categories` VALUES ('', '$submitter_id', '$name')";
		$res =& $this->db->query($sql);
		if(PEAR::isError($res)) {
			throw new SAException($res->getMessage());
		}
	}
	/**
	 * Delete files formerly attached to the publication from its storage location
	 *
	 * @param int $pid
	 */
	public function delete_files($publication_id)
	{
		$dirpath = "../storage/$publication_id/";
		$handle = @opendir($dirpath);
		if (!$handle)
			return;
		while ($file = readdir($handle))
		{
			if (is_file($path="../storage/$publication_id/".$file))
				unlink($path);
		}
		closedir($handle);
		$res = $this->db->query("DELETE FROM `documents` WHERE publication_id=?", $publication_id);
		if (PEAR::isError($res))
			throw new SAException($res->getMessage());
    	if (!rmdir($dirpath))
    		throw new SAException("Directory couldn't be deleted.");
	}

	/**
	 * Add document to the publication
	 *
	 * @param int  $publication_id
	 * @param string $title publication title
	 */
	public function add_file($publication_id)
	{

		$file =& $_FILES['file']['tmp_name'];
		$name =& $_FILES['file']['name'];
		$extension = substr($name, strrpos($name, ".") + 1);
		if ((!is_uploaded_file($file) && $file))
			throw new SAException("Not an uploaded file!");
		if ($file) {
			$convertor = new Convertor($this->db, $publication_id);
			if(!file_exists("../storage/$publication_id"))
				mkdir("../storage/$publication_id");
			$res = move_uploaded_file($file, "../storage/$publication_id/".$name);
			$convertor->add_file($name);
			if (!$res) {
				throw new SAException("Can't move uploaded file.");
			}
			$convertor->finish();
		}
	}

}
?>