<?php
require_once('Contents.inc.php');

/**
 * Managing conferences
 *
 */
final class Contents_conferences extends Contents
{

	/**
	 * Execute contents tab 9
	 *
	 */
	public function execute() {
		include '../help/Help.php';
		if ($this->post['add_conference2']) {
			try {
				add_conference2($this->db, $this->post['name'], $this->post['abbreviation'], $this->auth_module->get_id(), $this->post['description'], $this->post['first_year']);
				$this->smarty->assign('operation_success', 'Conference 2 has been added');
				//$this->display_conferences_list();
				$this->display_conferences2_list();
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
				//$this->display_conferences_list();
				$this->display_conferences2_list();
			}
		}elseif ($this->post['add_conference_year']) {
			try {
					$conference2_id=$_SESSION["conference2_id"];
					add_conference_year($this->db, $this->post['name'], $conference2_id,$this->post['w_year'],$this->post['w_from'], $this->post['w_to'], $this->post['location'], $this->post['isbn'], $this->post['description'], $this->auth_module->get_id());
		
					$this->smarty->assign('operation_success', 'Year of conference has been added.');
					$this->display_conf_year_list($conference2_id);
					//$this->display_conferences2_list();
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
				$this->display_conf_year_list($conference2_id);
			}
		}elseif ($this->post['add_conference_year_c']) {
			try {
					$conference2_id=$_SESSION["conference2_id"];
					$publisher_id= $this->post['publisher'];
					if(!$publisher_id){
						$publisher_id=0;
					}
					add_conference_year_c($this->db, $this->post['name'], $conference2_id,$this->post['w_year'],$this->post['w_from'], $this->post['w_to'], $this->post['location'], $this->post['isbn'], $this->post['description'], $publisher_id, $this->auth_module->get_id());
					$this->smarty->assign('operation_success', 'Year of conference has been added.');
					$this->display_conf_year_list($conference2_id);
					//$this->display_conferences2_list();
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
				$this->display_conf_year_list($conference2_id);

			}	
		} 
		elseif ($this->post['delete_files'] && $this->get['pid']){
			try {
				$this->delete_files($this->get['pid']);
				$this->smarty->assign('operation_success', 'Files has been deleted.');
				$this->display_overview($this->get['pid']);
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
				$this->display_overview($this->get['pid']);
			}
		} elseif ($this->post['add_file'] && $this->get['pid']) {
			try {
				$this->add_file($this->get['pid']);
				$this->smarty->assign('operation_success', 'File has been added.');
				$this->display_overview($this->get['pid']);
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
				$this->display_overview($this->get['pid']);
			}
		}
		 elseif ($ea=$this->post['edit_conference2']) {//$ea is array with only one element in format: $conference2_id => "změnit"
			try {
				if(is_array($ea)) foreach($ea as $conference2_id => $v) {
					$this->display_edit_conference2($conference2_id);
				}
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				die($e->getMessage());
			}
		} elseif ($ea=$this->post['edit_conference_year']) {//$ea is array with only one element in format: $conference_year_id => "změnit"
			try {
				if(is_array($ea)) foreach($ea as $conference_year_id => $v) {
					$this->display_edit_conference_year($conference_year_id);
				}
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				die($e->getMessage());
			}
		} elseif ($ea=$this->post['overview']) {//$ea is array with only one element in format: $conference_year_id => "změnit"
			try {
				if(is_array($ea)) foreach($ea as $publication_id => $v) {
					$this->display_overview($publication_id);
				}
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				die($e->getMessage());
			}
		} elseif ($ea=$this->post['choose_conf_year']) {//$ea is array with only one element in format: $conference2_id => "choose"
			try {
				if(is_array($ea)) foreach($ea as $conference2_id => $v) {
					$_SESSION["conference2_id"] = $conference2_id;

					$this->display_conf_year_list($conference2_id);
				}
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				die($e->getMessage());
			}

		} elseif ($ea=$this->post['display_publications']) {
			try {
				if(is_array($ea)) foreach($ea as $conference_year_id => $v) {
					$_SESSION["conference_year_id"] = $conference_year_id;

					$this->display_publications($conference_year_id);
				}
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				die($e->getMessage());
			}

		} elseif ($this->post['save_edited_conference2']) {
			try {
				update_conference2($this->db, $this->post['conference2_id'], $this->post['name'], $this->post['abbreviation'], $this->post['first_year'], $this->post['description'], $this->auth_module->get_id());
				$this->smarty->assign('operation_success', 'The conference 2 has been updated');
				$this->smarty->assign('refresh', '1 ; URL=index.php?tab=9');
				$this->smarty->display('contents_conferences.tpl');
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
				//die($e->getMessage());
				$this->display_edit_conference2($this->post['conference2_id']);
			}
		} elseif ($this->post['save_edited_conference_year']) {
			try {
				$conference2_id=$_SESSION["conference2_id"];

				update_conference_year($this->db, $this->post['conference_year_id'], $this->post['name'], $this->post['w_year'], $this->post['w_from'], $this->post['w_to'], $this->post['location'], $this->post['isbn'], $this->post['description'], $this->auth_module->get_id());
				$this->smarty->assign('operation_success', 'The conference year has been updated');
				
				$this->display_conf_year_list($conference2_id);

			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
			//die($e->getMessage());
				//$this->display_edit_conference_year($conference_year_id);

				$this->display_conf_year_list($conference2_id);
			}
		// save with publisher
		} elseif ($this->post['save_edited_conference_year_p']) {
			try {
				$conference2_id=$_SESSION["conference2_id"];
				$publisher_id= $this->post['publisher'];
				if(!$publisher_id){
					$publisher_id=0;
				}

				update_conference_year_p($this->db, $this->post['conference_year_id'], $this->post['name'], $this->post['w_year'], $this->post['w_from'], $this->post['w_to'], $this->post['location'], $this->post['isbn'], $this->post['description'],$publisher_id, $this->auth_module->get_id());
				$this->smarty->assign('operation_success', 'The conference year has been updated');
				
				$this->display_conf_year_list($conference2_id);

			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
			//die($e->getMessage());
				//$this->display_edit_conference_year($conference_year_id);

				$this->display_conf_year_list($conference2_id);
			}
		} elseif ($da=$this->post['delete_conference2']) {//$da is array with only one element in format: [...] => $conference2_id
			try {
				if(is_array($da)) foreach($da as $conference2_id => $v) {
					$affected = delete_conference2_check($this->db, $conference2_id);
					if ($affected)
						$this->smarty->assign('operation_success', 'Conference has been deleted.');
					else {
						$this->smarty->assign('operation_error', 'Conference has not been deleted because there are some Years of this conference.');
					}
					//$this->display_conferences_list();
					$this->display_conferences2_list();
				}
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
			}

		} elseif ($da=$this->post['delete_conference_year']) {//$da is array with only one element in format: [...] => $conference_year_id
			try {
				if(is_array($da)) foreach($da as $conference_year_id => $v) {

					$conference2_id=$this->get_conference2_id($conference_year_id);
					delete_conference_year($this->db, $conference_year_id);
					$this->smarty->assign('operation_success', 'Year of conference has been deleted.');
	
					$this->display_conf_year_list($conference2_id);
				}
			} catch(SAException $s) {
				die($s->getMessage());
			} catch (Exception $e) {
				$this->smarty->assign('operation_error', $e->getMessage());
			}
		} else {
			//$this->display_conferences_list();
			$this->display_conferences2_list();
		}

	}

	private function get_conference2_id($conference_year_id) {
		$sql = "SELECT conference2_id
				FROM `conference_year`
				WHERE id='$conference_year_id'";
		$conference2_id = $this->db->getOne($sql);
		return $conference2_id;
	}



	/**
	 * Show list of conferences2
	 *
	 */
	private function display_conferences2_list() {
		switch($this->get['order']) {
			case(1): $order_by = "ORDER BY name"; break;
			case(2): $order_by = "ORDER BY abbreviation"; break;
			case(3): $order_by = "ORDER BY description"; break;
			case(4): $order_by = "ORDER BY first_year"; break;
			default: $order_by = "ORDER BY name";
		}
		$sql = "SELECT *
				FROM `conference2`
				".$order_by; //select only complete conference2 with name and year, ommit 'private' non-complete records. Allow displaying non-complete records only to current user
		$sql_sec = "
				SELECT conference2_id
				FROM `conference_year`
				GROUP BY conference2_id
				HAVING COUNT(conference2_id) > 0";
		$conference2 = $this->db->getAll($sql, array(), DB_FETCHMODE_ASSOC);
		$warning = $this->db->getAll($sql_sec, array(), DB_FETCHMODE_ORDERED);
		if (is_array($conference2)) foreach ($conference2 as $i => $v) { //assign warnings
			if (in_array(array(0 => $v['id']), $warning))
				$conference2[$i]['warning'] = 1;
		}
		$this->smarty->assign('show_conference', 1);
		$this->smarty->assign('conference2', $conference2);
		$this->smarty->display('contents_conferences.tpl');
	}


	/**
	 * Display edit form of the conference2
	 *
	 * @param int $conference2_id
	 */
	private function display_edit_conference2($conference2_id) {
		$sql = "SELECT *
				FROM `conference2`
				WHERE id='$conference2_id'";
		$data =& $this->db->getRow($sql, array(), DB_FETCHMODE_ASSOC);
		if (PEAR::isError($data)) {
    		throw new SAException($data->getMessage());
		}
		$this->smarty->assign('edit_conference2', 1); //determine which part of template to use
		$this->smarty->assign('conference2_id', $conference2_id);
		$this->smarty->assign('name', $data['name']);
		$this->smarty->assign('abbreviation', $data['abbreviation']);
		$this->smarty->assign('description', $data['description']);
		$this->smarty->assign('first_year', $data['first_year']);
		$this->smarty->display('contents_conferences.tpl');
	}

	/**
	 * Display edit form of the conference year
	 *
	 * @param int $conference_year_id
	 */
	private function display_edit_conference_year($conference_year_id) {
		$sql = "SELECT *
				FROM `conference_year`
				WHERE id='$conference_year_id'";
		$data =& $this->db->getRow($sql, array(), DB_FETCHMODE_ASSOC);
		if (PEAR::isError($data)) {
    		throw new SAException($data->getMessage());
		}
		$this->smarty->assign('edit_conference_year', 1); //determine which part of template to use
		$this->smarty->assign('conference_year_id', $conference_year_id);
		$this->smarty->assign('name', $data['name']);
		$this->smarty->assign('w_year', $data['w_year']);
		$this->smarty->assign('w_from', $data['w_from']);
		$this->smarty->assign('w_to', $data['w_to']);
		$this->smarty->assign('location', $data['location']);
		$this->smarty->assign('isbn', $data['isbn']);
		$this->smarty->assign('description', $data['description']);
		$this->smarty->assign('selected_publisher', $data['publisher_id']);

		//naplnn selectu s vydavateli	
		$sql = "SELECT id, name
				FROM `publisher`
				ORDER BY name";
		$arr = $this->db->getAssoc($sql);
		if (PEAR::isError($arr))
			throw new SLException($arr->getMessage());
		$this->smarty->assign('publisher', htmlspecialchars_rec($arr));

		$this->smarty->display('contents_conferences.tpl');
	}

	/**
	 * Display choose form of the conference2 year
	 *
	 * @param int $conference2_id
	 */
	private function display_conf_year_list($conference2_id) {
		switch($this->get['order']) {
			case(1): $order_by = "ORDER BY name"; break;
			case(2): $order_by = "ORDER BY w_year"; break;
			case(3): $order_by = "ORDER BY w_from"; break;
			case(4): $order_by = "ORDER BY w_to"; break;
			case(5): $order_by = "ORDER BY location"; break;
			case(6): $order_by = "ORDER BY isbn"; break;
			case(7): $order_by = "ORDER BY description"; break;
			default: $order_by = "ORDER BY w_year";
		}

		
		$sql = "SELECT cy.id as id, cy.name,  cy.w_year, cy.w_from, cy.w_to, cy.location, cy.isbn, cy.description, cy.publisher_id, p.name as publisher_name
				FROM `conference_year` cy LEFT JOIN publisher p on p.id=cy.publisher_id
				WHERE conference2_id= $conference2_id
				".$order_by; //select only complete conference2 with name and year, ommit 'private' non-complete records. Allow displaying non-complete records only to current user
				
		$sql_sec = "SELECT conference_year_id
				FROM `publication`
				GROUP BY conference_year_id
				HAVING COUNT(conference_year_id) > 0";

		$conference_year = $this->db->getAll($sql, array(), DB_FETCHMODE_ASSOC);
		$publisher_name = $this->db->getAll($sql, array(), DB_FETCHMODE_ASSOC);
		$warning = $this->db->getAll($sql_sec, array(), DB_FETCHMODE_ORDERED);
		if (is_array($conference_year)) foreach ($conference_year as $i => $v) { //assign warnings
			if (in_array(array(0 => $v['id']), $warning))
				$conference_year[$i]['warning'] = 1;
		}
		$this->smarty->assign('choose_conf_year', 1);
		$this->smarty->assign('conference_year', $conference_year);

		//naplnn selectu s vydavateli	
		$sql = "SELECT id, name
				FROM `publisher`
				ORDER BY name";
		$arr = $this->db->getAssoc($sql);
		if (PEAR::isError($arr))
			throw new SLException($arr->getMessage());
		$this->smarty->assign('publisher', htmlspecialchars_rec($arr));

		$this->smarty->display('contents_conferences.tpl');

	}
	/**
	 * Display publications
	 *
	 * 
	 */
	private function display_publications($conference_year_id) {
		switch($this->get['order']) {
			case(1): $order_by = "ORDER BY name"; break;
			case(2): $order_by = "ORDER BY w_year"; break;
			case(3): $order_by = "ORDER BY w_from"; break;
			case(4): $order_by = "ORDER BY w_to"; break;
			case(5): $order_by = "ORDER BY location"; break;
			case(6): $order_by = "ORDER BY isbn"; break;
			case(7): $order_by = "ORDER BY description"; break;
			default: $order_by = "ORDER BY title";
		}

		$sql = "SELECT id, title, submitter_id, pub_type
				FROM `publication`
				WHERE conference_year_id= $conference_year_id
				".$order_by; //select only complete conference2 with name and year, ommit 'private' non-complete records. Allow displaying non-complete records only to current user

		$year_publications = $this->db->getAll($sql, array(), DB_FETCHMODE_ASSOC);

		$this->smarty->assign('display_publications', 1);
		$this->smarty->assign('year_publications', $year_publications);
		$this->smarty->display('contents_conferences.tpl');

	}
	/**
	 * Display everview
	 *
	 * 
	 */
	public function display_overview($publication_id)
	{
		$data = get_all_publication_data($this->db, $publication_id);
		$date_arr = explode('-', $data['issue_date']);
		foreach ($data as $i => $v)
		{
			$this->smarty->assign($i, $v);
		}

		//attributes
		$sql = "SELECT DISTINCT id, name, description, confirmed
				FROM `attrib_storage` JOIN `attributes`
				ON attrib_storage.attributes_id=attributes.id
				WHERE attrib_storage.publication_id = '$publication_id'";
		$attributes = $this->db->getAll($sql, array(), DB_FETCHMODE_ASSOC);
		if (PEAR::isError($attributes)) {
			throw new Exception($attributes->getMessage());
		}
		$s = '';
		if (is_array($attributes))
		foreach ($attributes as $arr)
		{
			$s .=
			'<tr>
				<td><input type="checkbox" name="propagated_attributes[]" value="'.$arr['id'].'" '.($arr['confirmed']?'checked="checked" disabled="disabled"':'').' /></td>
				<td><strong>'.$arr['name'].'</strong></td>'.'
				<td>'.htmlspecialchars($arr['description']).'</td>'.'
				<td>'.htmlspecialchars($this->db->getOne("SELECT value FROM `attrib_storage` WHERE attributes_id='".$arr['id']."' AND publication_id='$publication_id'")).'</td>
			</tr>';
		}
		$this->smarty->assign('attributes', $s);

		$user_name = $this->db->getOne("SELECT name FROM `submitter` WHERE id=?", $data['submitter_id']);
		$user_surname = $this->db->getOne("SELECT surname FROM `submitter` WHERE id=?", $data['submitter_id']);
		if (PEAR::isError($user_name))
			throw new SAException($user_name->getMessage());
		if (PEAR::isError($user_surname))
			throw new SAException($user_surname->getMessage());
		$this->smarty->assign('user_name', $user_name);
		$this->smarty->assign('user_surname', $user_surname);

		//issue_date
		$issue_date_a = $this->db->getOne("SELECT issue_date FROM `publication` WHERE id=$publication_id");
		$issue_date_a=substr($issue_date_a,0, 7);
		$this->smarty->assign('issue_date_a', $issue_date_a);

		$publisher=$data['publisher_id'];
		$publisher_address = $this->db->getOne("SELECT address FROM `publisher` WHERE id=?", $data['publisher_id']);
		$this->smarty->assign('publisher_address', $publisher_address);

		$conference_year_id=$data['conference_year_id'];	
		$journal_id=$data['journal_id'];	

		$authors = get_authors($this->db, $publication_id);
		$categories = get_categories($this->db, $publication_id);
		$conference_year= get_conference_year_data($this->db, $conference_year_id);
		$conference2= get_conference2_data($this->db, $conference_year_id);
		$journal= get_journal_data($this->db, $journal_id);

		$this->smarty->assign('short_look', 1); //determine which part of template to use
		$this->smarty->assign('pid', $publication_id);
		$this->smarty->assign('title', $data['title']);
		$this->smarty->assign('booktitle', $data['booktitle']);
		$this->smarty->assign('pages', $data['pages']);
		$this->smarty->assign('pub_type', $data['pub_type']);
		$this->smarty->assign('isbn', $data['isbn']);

		$dp = new DocumentProvider($this->db, true);
		$files = $dp->get_file_links($publication_id);
		$this->smarty->assign('attached_files', $files);

		$this->smarty->assign('authors', $authors);
		$this->smarty->assign('categories', $categories);
		$this->smarty->assign('conference_year', $conference_year['conference_year']);
		$this->smarty->assign('conference2', $conference2['conference2']);
		$this->smarty->assign('journal', $journal['journal']);
		$this->smarty->assign('issn', $journal['issn']);

		$this->smarty->assign('tab', 9);

		$submitter_id=$this->auth_module->get_id();
		$publ_count = $this->db->getOne("SELECT COUNT(*) FROM `submitter_has_publication` WHERE publication_id=$publication_id AND submitter_id!=$submitter_id");
		$this->smarty->assign('publ_count', $publ_count);

		$this->smarty->display('contents_conferences.tpl');

	}
	/**
	 * Delete files formerly attached to the publication from its storage location
	 *
	 * @param int $pid
	 */
	public function delete_files($publication_id)
	{
		$dirpath = "../storage/$publication_id/";
		$handle = @opendir($dirpath);
		if (!$handle)
			return;
		while ($file = readdir($handle))
		{
			if (is_file($path="../storage/$publication_id/".$file))
				unlink($path);
		}
		closedir($handle);
		$res = $this->db->query("DELETE FROM `documents` WHERE publication_id=?", $publication_id);
		if (PEAR::isError($res))
			throw new SAException($res->getMessage());
    	if (!rmdir($dirpath))
    		throw new SAException("Directory couldn't be deleted.");
	}

	/**
	 * Add document to the publication
	 *
	 * @param int  $publication_id
	 * @param string $title publication title
	 */
	public function add_file($publication_id)
	{

		$file =& $_FILES['file']['tmp_name'];
		$name =& $_FILES['file']['name'];
		$extension = substr($name, strrpos($name, ".") + 1);
		if ((!is_uploaded_file($file) && $file))
			throw new SAException("Not an uploaded file!");
		if ($file) {
			$convertor = new Convertor($this->db, $publication_id);
			if(!file_exists("../storage/$publication_id"))
				mkdir("../storage/$publication_id");
			$res = move_uploaded_file($file, "../storage/$publication_id/".$name);
			$convertor->add_file($name);
			if (!$res) {
				throw new SAException("Can't move uploaded file.");
			}
			$convertor->finish();
		}
	}

}
?>