<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="cs" lang="cs">
<head>
	<meta http-equiv="content-type" content="text/html; charset=utf-8" />
	<title>Database of publications - check of inserted data</title>
	<link rel="stylesheet" type="text/css" href="load.css" />
	<link rel="stylesheet" type="text/css" href="../common/header.css" />
	<script src="../contents/modify_publication.js" type="text/javascript"></script>
	<script src="../help/help.js" type="text/javascript"></script>
	{literal}
	<script type="text/javascript">
	//<![CDATA[
	function addInput()
	{
		var ni = document.getElementById('files');
		var numi = document.getElementById('base_inp');
		var newInput = document.createElement('input');
		newInput.setAttribute("type", "file");
		newInput.setAttribute("name", numi.name);
		var newBr = document.createElement('br');
		ni.appendChild(newInput);
		ni.appendChild(newBr);
	}

	//]]>
	</script>
	{/literal}
</head>
<body>
	{include file="header.tpl"}
	{include file="header2.tpl"}

	<div id="mainpanel">
	<div id="content">
	<div id="mainpanel-inside">
		{if $report}
			<div class="report">
				Publication you are inserting has particular defects, which you may ignore
				and save the publication. For the compatibility with BibTeX format
				we recommend go back to the previous form
				and correct these defects: <br /><br />
				<span style="color: #FF8C00">{$report}</span>
			</div>
		{/if}
		{if $operation_error neq ""}
			<span class="error">{$operation_error}</span><br/>
		{elseif $operation_success neq ""}
			<span class="success">{$operation_success}</span><br/>
		{/if}



		<strong>Type of publication:</strong> {$pub_type}
		<br />
		<strong>Title:</strong> {$title}
		<br />
		{if $booktitle}<strong>Booktitle:</strong> {$booktitle}<br />{/if}

		{if $volume}<strong>vol.:</strong> {$volume}<br />{/if}
		{if $number}<strong>no.:</strong> {$number}<br />{/if}
		{if $chapter}<strong>Chapter:</strong> {$chapter}<br />{/if}
		{if $pages}<strong>Pages:</strong> {$pages}<br />{/if}
		{if $series}<strong>Series:</strong> {$series}<br />{/if}
		{if $edition}<strong>Edition:</strong> {$edition}<br />{/if}
		{if $howpublished}<strong>Howpublished:</strong> {$howpublished}<br />{/if}
		{if $type}<strong>Type of report:</strong> {$type}<br />{/if}
		{if $institution}<strong>Institution:</strong> {$institution}<br />{/if}
		{if $school}<strong>School:</strong> {$school}<br />{/if}
		{if $organization}<strong>Organization:</strong> {$organization}<br />{/if}
		{if $issue_date}<strong>Issue Date:</strong> {$issue_date}<br />{/if}
		{if $year}<strong>Year:</strong> {$year}<br />{/if}

		{if $journal_data}
			<strong>Journal:</strong> {$journal_data.journal}<br />
			{if $journal_data.issn}ISSN:{$journal_data.issn}<br />{/if}
		{/if}

		{if $conference2_data}
			<br />
			<strong>Conference2:</strong> {$conference2_data.conference2}<br />

			{if $conference2_abbreviation neq '0000'}Abbreviation:{$conference2_abbreviation}<br />{/if}
			{if $conference2_first_year neq '0000'}First year:{$conference2_first_year}<br />{/if}
			{if $conference2_description}Description: {$conference2_description}<br />{/if}
		{/if}

		{if $conference_year_data}
			<br />
			<strong>Conference_year:</strong> {$conference_year_data.conference_year}<br />
			{if $conference_year_w_year neq '0000'}Year:{$conference_year_w_year}<br />{/if}
			{if $conference_year_w_from neq '0000-00-00'}From:{$conference_year_w_from}<br />{/if}
			{if $conference_year_w_to neq '0000-00-00'}To:{$conference_year_w_to}<br />{/if}
			{if $conference_year_location}Location:{$conference_year_location}<br />{/if}
			{if $conference_year_isbn}ISBN:{$conference_year_isbn}<br />{/if}
			{if $conference_year_description}Description:{$conference_year_description}<br />{/if}
			{if $conference_year_publisher_id}Publisher_id:{$conference_year_publisher_id}<br />{/if}			
		{/if}


		{if $publisher_data}
			<br />
			<strong>Publisher:</strong> {$publisher_data.publisher}<br />
			{if $publisher_data.publisher_address}Address: {$publisher_data.publisher_address}<br />{/if}
		{/if}
		{if $authors}<br /><strong>Authors:</strong> {$authors}<br />{/if}
		{if $isbn}<strong>ISBN:</strong> {$isbn}<br />{/if}
		{if $issn}<strong>ISSN:</strong> {$issn}<br />{/if}
		{if $note}<strong>Note:</strong> {$note}<br />{/if}
		{if $url}<strong>URL:</strong> {$url}<br />{/if}

		{if $categories or $tmp_cat}
			<strong>Publication will be included in the following categories:</strong>
			{foreach from=$categories item=current}{$current} {/foreach}
			{foreach from=$tmp_cat item=current}{$current} {/foreach}
			<br />
		{/if}

		<br />
		{if $attributes or $tmp_attr}
			<strong>Extending attributes:</strong><br />
			<!-- extra attributes -->
			{$attributes}
			<!-- temporarily added attributes -->
			{$tmp_attr}
		{/if}

		<form action="index.php" method="post" enctype="multipart/form-data" accept-charset="UTF-8">
		<div id="files">
			<br />
			You can add files to the publication {if $permitted_extensions}({$permitted_extensions}){/if}:
			<br />
			<input type="button" name="text_addfile" value="add another one file" onclick="addInput();"><br />
			<input id="base_inp" type="file" name="documents[]"/><br />
		</div>
		
		Set as My publication? <input type="checkbox" checked name="want_set" value="yes">
			<a id="hide_13" style="display:none" href="javascript:hidediv(13)"><img src="../graphics/b_help.png" alt="help"/></a>
			<a id="show_13" href="javascript:showdiv(13,'{$13_help}')"><img src="../graphics/b_help.png" alt="help"/></a>	
			<center><div id="hideShow_13" style="visibility:hidden" class="help_class_half"></div></center>

		<br /> 

		<table id="form_nova_publikace" border="0" cellspacing="20" summary="">
		<tr>
			<td class="left">
				<input type="hidden" name="prev_stage" value="2" />
				<input type="submit" name="previous" value="&lt;&lt; previous" />
			</td>
			<td class="right">
				<input type="hidden" name="next_stage" value="4" />
				<input type="submit" name="next" value="finish"/>
			</td>

			
		</tr>
		</table>
		</form>
	</div>
	</div>
	</div>
</body></html>