<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="cs" lang="cs">
<head>
	<meta http-equiv="content-type" content="text/html; charset=utf-8" />
	<title>Database of publications - {$title}</title>
	<link rel="stylesheet" type="text/css" href="user.css" />
	<link rel="stylesheet" type="text/css" href="common/header.css" />
	<link rel="stylesheet" type="text/css" href="submitter.css" />
	{if $tab eq 'modify'}<script src="admin/modify_publication.js" type="text/javascript"></script>{/if}
	<script src="help/help.js" type="text/javascript"></script>
	{literal}
	<script type="text/javascript">
	//<![CDATA[
		function init_annot()
		{
			{/literal}
			{foreach from=$editable_annot item=annot}
				document.getElementById('textarea_{$annot.id}').style.display = 'none';
			{/foreach}
			{literal}
		}

		function edit(id)
		{
			text = document.getElementById('text_' + id);
			textarea = document.getElementById('textarea_' + id);
			text.style.display = 'none';
			textarea.style.display = 'block';
		}
	//]]>
	</script>
	{/literal}
	{literal}
		<script src="http://vlsi.felk.cvut.cz/Publikace-test/contents/modify_publication.js" type="text/javascript"></script>
	{/literal}
</head>
<body {if $tab eq 'modify'}onload="init_ajax();"
	{elseif $tab eq 'annotations'}onload="init_annot();"{/if}>

	{include file="header.tpl"}
	{include file="header2.tpl"}


<div class="rawpanel">
	<a href="index.php?{$smarty.session.search_qs}&amp;advanced=false">&lt;&lt; go back</a><br />

	<ul id="publ_menu">
		<li {if $smarty.get.tab eq 1 or $smarty.get.tab eq ''}class="active"{/if}><a href="?pid={$smarty.get.pid}&amp;tab=1">Overview</a></li>
		{if $level <= 1}<li {if $smarty.get.tab eq 2}class="active"{/if}><a href="?pid={$smarty.get.pid}&amp;tab=2">Modify</a></li>{/if}
		<li {if $smarty.get.tab eq 3}class="active"{/if}><a href="?pid={$smarty.get.pid}&amp;tab=3">Annotations</a></li>
	</ul>
	<div id="publication_header">
		<h1>{$title_label}</h1>
		Authors: <a href="?authors={$author_surnames}&amp;advanced=false">{$authors_label}</a>
		{if $categories_label}<br /><span class="categories_strip">Categories: {$categories_label}</span>{/if}
	</div>

	<div id="publication_board">
		{if $operation_error}
			<br />
			<span class="error">{$operation_error}</span><br/><br/>
		{elseif $operation_success}
			<br />
			<span class="success">{$operation_success}</span><br/><br/>
		{/if}

		{if $tab eq 'overview'}
		<div class="overview_panel">
			<table class="overview_tbl" cellpadding="0" cellspacing="0" border="0" summary="overview">
			<tr><td>
			<div class="overview_fields">
				{if $abstract}<strong>Abstract:</strong><br /> {$abstract|trim|nl2br}<br /><br />{/if}
				<strong>Type of publication:</strong> {$pub_type}<br />
				{if $booktitle}<strong>Booktitle:</strong> {$booktitle}<br />{/if}
				{if $author}<strong>Authors:</strong> {$author}<br />{/if}
				{if $volume}<strong>Volume:</strong> {$volume}<br />{/if}
				{if $number}<strong>Number:</strong> {$number}<br />{/if}
				{if $chapter}<strong>Chapter:</strong> {$chapter}<br />{/if}
				{if $pages}<strong>Pages:</strong> {$pages}<br />{/if}
				{if $series}<strong>Series:</strong> {$series}<br />{/if}
				{if $edition}<strong>Edition:</strong> {$edition}<br />{/if}
				{if $howpublished}<strong>Howpublished:</strong> {$howpublished}<br />{/if}
				{if $type}<strong>Type of report:</strong> {$type}<br />{/if}
				{if $institution}<strong>Edition:</strong> {$institution}<br />{/if}
				{if $school}<strong>School:</strong> {$school}<br />{/if}
				{if $organization}<strong>Organization:</strong> {$organization}<br />{/if}

				{if $journal}<strong>Journal:</strong> {$journal}<br />{/if}

				{if $conference2}<br /><strong>Conference2:</strong><br />Name: {$conference2}<br />{/if}
				{if $conference2_abbreviation}Abbreviation: {$conference2_abbreviation}<br />{/if}
				{if $conference2_first_year && $conference2_first_year<>"0000"}First year: {$conference2_first_year}<br />{/if}
				{if $conference2_description}Description: {$conference2_description}<br />{/if}

				{if $conference_year}<br /><strong>Year of Conference:</strong><br />Name: {$conference_year}<br />{/if}
				{if $conference_year_w_year && $conference_year_w_year<>"0000"}Year: {$conference_year_w_year}<br />{/if}
				{if $conference_year_w_from && $conference_year_w_from<>"0000-00-00"}From: {$conference_year_w_from}<br />{/if}
				{if $conference_year_w_to && $conference_year_w_to<>"0000-00-00"}To: {$conference_year_w_to}<br />{/if}
				{if $conference_year_location}Location: {$conference_year_location}<br />{/if}
				{if $conference_year_isbn}ISBN: {$conference_year_isbn}<br />{/if}
				{if $conference_year_description}Description: {$conference_year_description}<br />{/if}


				{if $publisher}<br /><strong>Publisher:</strong><br />Name: {$publisher}<br />{/if}
				{if $publisher_address}Address: {$publisher_address}<br />{/if}

				<br />
				{if $year}<strong>Year: </strong>{$year}<br />{/if}
				{if $month}<strong>Month: </strong>{$month}<br />{/if}
				{if $isbn}<strong>ISBN:</strong> {$isbn}<br />{/if}
				{if $issn}<strong>ISSN:</strong> {$issn}<br />{/if}
				{if $note}<strong>Note:</strong> {$note}<br />{/if}
				{if $url}<strong>URL:</strong> {$url}<br />{/if}
			</div>
			</td><td>
			<div style="float: right;">
				<div class="bibtex_definition">
					<div class="header">Bibtex definition:</div>
					<div class="content">{$bibtex}</div>
				</div>
				{if $files}
				<br /><br />
				<div class="download">
					<div class="header">Downloads:</div>
					<div class="content">{$files}</div>
				</div>
				{/if}
			</div>
			</td></tr>
			</table>
			<hr class="cleaner" />
			<br /><br />
			<form method="post" action="" accept-charset="utf-8">

			<fieldset>
				<legend>Citation in <select name="format">{html_options options=$format selected=$selected_format}</select> <input type="submit" name="change_format" value="ok" /></legend>
				{$citation}
			</fieldset>
			<br />
			{if $level==0 || $level==1}
			<input type="submit" name="set_my_publication" value="set as my publication" />
			<a id="hide_16" style="display:none" href="javascript:hidediv(16)"><img src="graphics/b_help.png" alt="help"/></a>
			<a id="show_16" href="javascript:showdiv(16,'{$16_help}')"><img src="graphics/b_help.png" alt="help"/></a>	
			<center><div id="hideShow_16" style="visibility:hidden" class="help_class_half"></div></center>
			{/if}
			</form>
		</div>
		{elseif $tab eq 'modify'}
			<form action="" method="post" enctype="multipart/form-data" accept-charset="UTF-8">
			{include file='modify_publication.tpl'}
			</form>
		{elseif $tab eq 'annotations'}
			<form method="post" action="" accept-charset="utf-8">
			<textarea rows="3" cols="80" name="annotation"></textarea>
			<div class="right">
				<input type="submit" name="add_annotation" value="add annotation" />
				&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
				<label>private <input type="radio" name="scope" value="0" checked="checked" /></label>
				<label>global<input type="radio" name="scope" value="1" /></label>
			</div>
			</form>
			{if $editable_annot or $other_annot}<hr />{/if}
			{foreach from=$editable_annot item=annot}
			<form method="post" action="" accept-charset="utf-8" class="editable_annot">
				<div id="text_{$annot.id}">
					<em>{$annot.text}</em><br/><br/>
					by {$annot.owner}<br />
					<div class="right"><span class="btn" onclick="edit({$annot.id});">edit</span></div>
				</div>
				<div id="textarea_{$annot.id}">
					<textarea rows="3" cols="80" name="annotation">{$annot.text}</textarea>
					<br/><br/>
					<input name="delete_annotation" type="submit" value="delete" />
					<input name="update_annotation" type="submit" value="update" />
					<input name="id" type="hidden" value="{$annot.id}" />
				</div>
			</form>
			{/foreach}
			{foreach from=$other_annot item=annot}
			<form method="post" action="" accept-charset="utf-8" class="other_annot">
				<div id="text_{$annot.id}">
					<em>{$annot.text}</em><br/><br/>
					by {$annot.owner}<br />
					<div class="right"><span class="btn" onclick="edit({$annot.id});">edit</span></div>
				</div>
			</form>
			{/foreach}
		{/if}
	</div>
</div>
</body></html>
